/* 01 Jan 2000. Daniel Hellerstein (danielh@crosslink.net)
  Stand alone version of the e Updater remote client
*/


/**** Begin User changeable parameters ****/

/* Allow use of rsync encoding. 1=enable, 0=disable
   If you do not have the rxrsync.dll, you should set this to 0. 
   Note: the adler-32 check requires rxrsync.dll */
candorsync=1

/* allow use of GZIP encoding. 1=enable, 0=disable
   If you do not have the gzip.exe, you should set this to 0. */
candogzip=0

/* if the central servers you are visiting run updater as a cgi-bin script,
   enter the "CGI-BIN" prefix here. Typically, this will be CGI-BIN/.
   If these servers are running UpDater as an sre-http addon, leave this empty*/
cgi_prefix=''

/* the default server, or leave it blank*/
default_central_server=''

/* the default package name, or leave it blank */
default_package='!LIST'

/* default "destination directory", or leave it blank */
def_destdir=''

/* default "backup directory", or leave it blank for none */
def_backupdir=''

/* set of "encryption" specs. ENCRYPT.!BLOWFISH is an example,
  you can delete it if you will never use blowfish 
  Note that UPDATER has a built in "Simple" (32bit) encryption. */
ENCRYPT.!blowfish='bf -q -d %in %out "%key"'

/* a default "cached list of files" to use (instead of the default
   central server and package). Leave this blank to use the
   default server/package. */
list_of_files=''
   

/* file to log results to. Leave it blank to NOT log results */
logfile=''

/* interval to show "processing file" message, in quiet mode */
quiet_interval=25

/* default space delimited list of fully qualified (wildcards ok)
  files to skip (names as they will appear on your computer */
skiplist=''

/* max seconds to wait for each 1000 byte socket call.
   For slow connections, you may need to increase this */
timeout=30

/* criteria to use to determine whether to update a file:
   0=always, 1=check timestamp, 2=check crc32 hash */
def_criteria=2

/* Directory to save "list of packages", and "list of files", to.
   If empty, then these lists will not be saved */ 
updater_dir=''

/* amount of status message: 0=few, 1=some, 2=more */
verbose=1
   
/* program to use to view "list of files". Leave blank to suppress this
   option */
viewer='E'

/************* End of User changeable parameters ****************/

signal on error name badguys; signal on syntax name badguys
signal on halt name badguys2 ; signal on failure name badguys 

call check_dlls         /* load some dlls */
rng1=1 ; rng2=500000         /* 0 in range 2 means "last file */

say "       "cy_ye"UpDateMe: a stand-alone file updater "normal

/***** ---- loop starts here */
aoptold=''
do forever              

say

select
  when askupwd=1 then aopt11='M'
  when aoptold='' then  aopt11='P'
  when aoptold='P' then  aopt11='U'
  otherwise      aopt11='?'
end
aoptold=aopt11

call askopts aopt11

aopt1='Q'
askupwd=0

storestuff=get_package(list_of_files,cserver,thepackage,0,auser,apwd)  /* GET from central server */

if storestuff='' | askupwd=1 then iterate

/* special "display packages" request */
if strip(translate(thepackage))='!LIST' then do
  stuff0=storestuff
  say cy_ye" List of packages offered by "normal||reverse||cserver||normal
  parse var stuff0 . '0d0a'x stuff0
  nnd=0
  do until stuff0=''
     parse var stuff0 aline '0d0a'x stuff0
     parse var aline . pname pdesc 
     say bold||right(pname,12)||normal' '||left(pdesc,66)
     nnd=nnd+1
     if nnd=20 then do
        call charout,reverse' hit any key to continue ... 'normal
        foo=sysgetkey('noecho')
        nnd=0
     end /* do */
  end /* do */
  iterate
end

foo=parse_package(storestuff)
rng1=max(1,rng1)
rng2=min(rng2,entries.0)


/* now get the files ! */
stat.=0
didit.=0

retrys.=0
retrying=0

len1=length(entries.0)+1

if encrypts<>"" | (opts.!needprivs=1 & auser='') then do         /* will need security info */
   aa=ask_username()
end

/* ask for options */
if logfile<>'' then logfile=set_logfile(logfile,1)
say
hh=yesno(normal"  "bold"do you want to",'Continue Modify Reset','C','C')
if hh=2 then iterate
if hh=1  then do
   call askopts 'U'
end             /* 0 = Continue */

if logfile<>'' then do
  foo=write_message(logfile,1,'UpDateMe log on 'date('n')' 'time('n') )
  foo=write_message(logfile,1,'   Package: '||opts.!package)
  if  age>0 then do
      foo=write_message(logfile,1, '   (last updated: 'days 'days and ' hrs 'hours ago)')
  end
  else do
      foo=write_message(logfile,1,'   (just updated)')
  end
  foo=write_message(logfile,1,'   which is on the server at: '|| opts.!server)
  foo=write_message(logfile,1,'These will be written to your computer, using...')
  foo=write_message(logfile,1,'   Destination Directory: 'destdir)
  foo=write_message(logfile,1,'   # of files: 'entries.0 '(in 'entries.!dirct' directories)')
  foo=write_message(logfile,1,'   Backup Directory: 'backupdir)
  foo=write_message(logfile,1,' ')
end

tocheck=1+rng2-rng1

doretry:                /* jump here to retry unGETable files */
say
tt=bold'# of files to check: 'normal||tocheck
if norexxlib=1 then
    tt=tt||' 'cy_ye'(hit ctrl-c to abort)'normal
else
    tt=tt||' 'cy_ye'(hit ESC to abort)'normal
say tt
say 
call syssleep(0.33)

if logfile<>'' then do 
  foo=write_message(logfile,1,'# of files to check: '||tocheck)
  foo=write_message(logfile,1,' ')
end /* do */

didprocess=0

/* open up a socket (and try to re use it as much as possible */
gosock=sockhttp_opensock(,opts.!server)
say " Using socket # "gosock
if abbrev(gosock,'-1')=1 then do
  say "Error, unable to create socket to " server
  exit
end


/* temp file for use by sockhttp */
tempfile0=make_tempname('UD1',norexxlib,temp_dir)

/*** Start GETting files from the central server */
do mm0a=rng1 to rng2
  tempfile=tempfile0
  if norexxlib=0 then do                /*look for escape key */
      aesc=inkey('N')
      iesc=c2x(aesc)
      if iesc=d2x(27) then do
        say 
        say bold "Processing halted  at file # "normal||mm0a
        if datatype(gosock)='NUM' then foo=sockclose(gosock)
        leave
      end 
  end 
  didprocess=didprocess+1

  if quiet=1 then do
      if (mm0a//quiet_interval)=1 then do
         call charout,bold||' Processing file #: 'normal||mm0a'        '||'0d'x
      end /* do */
  end /* do */
  if retrying=0 then
     mm0=mm0a
  else
     mm0=retrys.mm0a

   cmm0=right(mm0,len1)': '
   afile=entries.mm0.!file
   afilel=strip(translate(afile,'\','/'),,'\')
   rdir0=strip(strip(translate(entries.mm0.!rdir,'\','/')),,'\')
   if rdir0='' then
      tofile=destdir||'\'||afilel
   else
      tofile=destdir||'\'||rdir0||'\'||afilel

/* skip check */
   if skiplist<>"" then do
       didskip=0
       do mm=1 to words(skiplist)
           awrd=strip(word(skiplist,mm))
           oo=wild_match(tofile,awrd)
           if oo<>0 then do             /* matches a skip pattern */
             stat.!skipped=stat.!skipped+1
             foo=write_message(logfile,quiet, ,
                                  cmm0||bold'Skipped 'normal'('awrd ' match) 'normal||tofile)
             didskip=1 ; leave
           end 
        end
        if didskip=1 then iterate
   end 
   
   todir=filespec('d',tofile)||filespec('p',tofile)
   if ais_dir(strip(todir,,'\'))=0 then do
       foo=sysmkdir2(todir)
       if foo<>0 then do
          stat.!nocreate=stat.!nocreate+1
           foo=write_message(logfile,quiet, ,
                           cmm0||reverse'ERROR 'normal'could not make directory for 'tofile)
          iterate
       end
   end

   backfile=''
   if backupdir<>'' then do
      backfile=backupdir'\'afilel
      backdir=filespec('d',backfile)||filespec('p',backfile)
      if ais_dir(strip(backdir,,'\'))=0 then do
        foo=sysmkdir2(backdir)
        if foo<>0 then do
          stat.!nocreate=stat.!nocreate+1
          foo=write_message(logfile,quiet, ,
                  cmm0||reverse'ERROR'normal' could not make backup directory for 'backfile)
          iterate
       end
     end                /* backupdir exists*/
   end          /* backupdir specified */

   foo='!'||strip(translate(tofile))
   didit.foo=1

/* check date first ? */
   arf=sysfiletree(tofile,'tt','FT')
   oldfile=''; timecheck=strip(timecheck)
   if tt.0<>0 then do           /* compare dates */
        oldfile=tofile
        if timecheck=1 then do                  /* update newer files only */
           parse var tt.1 todate . . .
           if left(todate,2)<70 then
              todate='20'||todate
           else
              todate='19'||todate
           if todate>= entries.mm.!date then do
                stat.!nochange=stat.!nochange+1
                if retrying=1 then retrys.0.!ok=retrys.0.!ok+1
                foo=write_message(logfile,quiet, ,
                        cmm0||bold'No change'normal' (timestamp check) in 'tofile)
                iterate
           end /* do */
        end                      /*timecheck */
        if candoadler=1 & timecheck=2 & entries.mm0.!crc<>'' then do          /* compare crc32?*/       
           thiscrc=fileadler(oldfile)
           if strip(translate(thiscrc))=strip(traNslate(entries.mm0.!crc)) then do
                stat.!nochange=stat.!nochange+1
                if retrying=1 then retrys.0.!ok=retrys.0.!ok+1
                foo=write_message(logfile,quiet,cmm0||bold'No change'normal' (crc32 check) in 'tofile)
                iterate
           end /* do */
        end /* do */
   end                /* found old version */

   aentry=entries.mm0.!entry
   req='/'||opts.!selector||'?package='opts.!package'&action=file&file='afile'&entry='aentry
   if retrying=1 then req=req'&no_encoding=1'

   if timecheck=3 & candoadler=1 & oldfile<>'' then do
      dmd4=rx_md4(oldfile,1)
      req=req'&md4='dmd4
   end 

   if candogzip=1 & opts.!GZIP=1 & entries.mm0.!noce=0 then do
     req=req'&gzip=1'
   end          

   if candorsync=1 & opts.!rsync=1 & entries.mm0.!noce=0 then do
      rsyncok=1
      req=req'&rsync=1'
   end
   else do
      rsyncok=0
   end

   if encrypts<>'' & shared_secret<>0 then do  /* shared_secret=0 means "suppress encryption */
      req=req'&encrypt='encrypts
   end 

   stuff=get_a_url(opts.!server,req,auser,apwd,oldfile,,tempfile)
  
   if stuff='' then do 
      if notmod=1 then do               /* 304 return */
         stat.!nochange=stat.!nochange+1
         if retrying=1 then retrys.0.!ok=retrys.0.!ok+1
         foo=write_message(logfile,quiet, ,
             cmm0||bold'No change'normal' (hash check) in 'tofile)
         iterate
      end 
      if notmod=2 then do               /* 304 return */
         stat.!nochange=stat.!nochange+1
         if retrying=1 then retrys.0.!ok=retrys.0.!ok+1
         foo=write_message(logfile,quiet, ,
                              cmm0||bold'No change'normal' (rsync check) in 'tofile)
         iterate
      end 
      stat.!noget=stat.!noget+1
      foo=write_message(logfile,quiet,cmm0||reverse'ERROR'normal' could not GET 'afile)
      if retrying=0 then do
         ir=retrys.0+1
         retrys.ir=mm0
         retrys.0=ir 
      end
      iterate
   end /* do */

  if oldfile<>'' then do
     foo=do_backup(tofile,backfile)   /* backup file before overwriting? */
  end

/* write response to the "tofile" */
   if response_tofile=0 then do
      call write_stuff_tofile 
      if len_stuff=0 then iterate
   end 
   else do
      tempfile=stuff
      call copy_tempfile_tofile 
      if len_stuff=0 then iterate
   end 


   addo=''
   if didgzip+didrsync+diddecrypt>0 then do
        addo=' < 'orisize' w/'
        if didrsync=1 then addo=addo||' RSY'  
        if didgzip=1 then addo=addo||' GZ'
        if diddecrypt=1 then addo=addo||' DeC'  
    end /* do */
    if oldfile='' then do
       stat.!created=stat.!created+1
       if retrying=1 then retrys.0.!ok=retrys.0.!ok+1
       zz=cmm0||' 'bold'Creating 'normal||tofile '('len_stuff' bytes'||addo
       foo=write_message(logfile,quiet,zz)
   end
   else do
       if retrying=1 then retrys.0.!ok=retrys.0.!ok+1
          
          zz=cmm0||bold'Updating 'normal||tofile '('len_stuff' bytes'||addo
          foo=write_message(logfile,quiet,zz)
       end
       stat.!updated=stat.!updated+1
   end
   
end

foo=write_message(logfile,0,' ')
foo=write_message(logfile,0,bold'# files processed: 'normal||didprocess)
foo=write_message(logfile,0,bold'          created: 'normal||stat.!created)
foo=write_message(logfile,0,bold'          updated: 'normal||stat.!updated)
foo=write_message(logfile,0,bold'      not changed: 'normal||stat.!nochange)
foo=write_message(logfile,0,bold'          skipped: 'normal||stat.!skipped)
nerrs=stat.!nocreate+stat.!noget
foo=write_message(logfile,0,bold'           Errors: 'normal||nerrs)
if nerrs>0 then do
  foo=write_message(logfile,0,'               GET failed= 'stat.!noget)
  foo=write_message(logfile,0,'            write problem= 'stat.!nocreate)
end /* do */
foo=write_message(logfile,0,' ')
deletes=0
/* remove files? */
if dodelete=1 then do
   ff=destdir'\*.*'
   aa=sysfiletree(ff,'alls','FOS')
   do mm=1 to alls.0
      a1='!'||translate(strip(alls.mm))
      if didit.a1=0 then do
         deletes=deletes+1
         foo=sysfiledelete(alls.mm)
         if foo=0 then
           foo=write_message(logfile,quiet, ,
                bold' deleted 'normal||alls.mm )
         else
           foo=write_message(logfile,quiet, ,
                                 reverse' failed to delete 'normal||alls.mm )
      end
   end 
    foo=write_message(logfile,0, ,
         bold' Number of (orphan) files deleted: 'normal||deletes)
end
if retrys.0>0  & retrying=0 then do  /* retry (once) unGETable uris? */
   say ' '
   foo=write_message(logfile,0,' ')
   foo=write_message(logfile,0,bold' ReGET 'normal||retrys.0' unavailable files ')
   foo=write_message(logfile,0,' ')
   retrying=1 ;tocheck=retrys.0
   rng1=1  ; rng2=retrys.0
   stat.=0
   signal doretry
end

/* warn client of missing info */
if retrys.0>retrys.0.!ok  then do  
   foo=write_message(logfile,0,'')
   unavail=retrys.0-retrys.0.!Ok
   foo=write_message(logfile,0,cy_ye"Warning: "unavail" files were not successfully obtained"normal)
   foo=write_message(logfile,0,'You should re-access this UpDater package, request the "latest version",')
   foo=write_message(logfile,0,'and try again.')
   foo=write_message(logfile,0,'')
end

foo=write_message(logfile,0,cy_ye' Total elapsed time: 'normal||time('e')||' seconds')
if datatype(gosock)='NUM' then foo=sockclose(gosock)

end             /* OF BIG LOOP */
atend:


/*** jump here on error */
badguys:
say "UpDateMe error "Rc " at " sigl
if datatype(gosock)='NUM' then foo=sockclose(gosock)
call goodbye
if logfile<>'' & logfile<>'LOGFILE' then call lineout logfile
exit

badguys2:
say 
say 
say "UpDateMe "bold"halted"normal" after processing entry #"mm0a
if datatype(gosock)='NUM' then foo=sockclose(gosock)
foo=sysfiledelete(listfile)
call goodbye

if logfile<>'' & logfile<>'LOGFILE' then call lineout logfile
exit


/*************/
/* copy contents of tempfile to tofile-- use rexxlib move if possible
tofile should be deleted by do_backfile */

copy_tempfile_tofile:

len_stuff=0

if norexxlib=0 then do          /* use rexxlib procedures */
  if translate(filespec('d',tofile))=translate(filespec('d',tempfile)) then do
      fii=dosrename(tempfile,tofile)
      if fii=0 then DO 
          foo=write_message(logfile,quiet,fii'  Warning: Unable to rename to: 'tofile)
          RETURN 0            
      end 
   end
   else do                 /* can't move, try copying */
       fii=doscopy(tempfile,tofile,'R')
       if fii<>0 then DO 
          foo=write_message(logfile,quiet,'  Warning: Unable to copy to: 'tempfile' 'tofile)
          RETURN 0            
       end 
   END
   len_stuff=stream(tofile,'c','query size')
   return 1  
END

goo=stream(tempfile,'c','open read')
if abbrev(strip(translate(goo)),'READY')=0 then do
     foo=write_message(logfile,quiet,fii'  Warning: Unable to open: 'tempfile)
     RETURN 0            
end 
sz=charin(tempfile,'c','query size')
if sz=0 | sz='' then do
     foo=write_message(logfile,quiet,fii'   Warning: empty file: 'tempfile)
     RETURN 0            
end 

foo=stream(tofile,'c','open write')
if abbrev(translate(foo),'READY')=0 then do
       foo=write_message(logfile,quiet,reverse'ERROR'normal' unable to open 'tofile)
       stat.!nocreate=stat.!nocreate+1
       return 0
end 

do mmw=1 to sz by 10000
   jjsize=min(10000,1+sz-mmw)
   gin=charin(tempfile,mmw,jjsize)
   foo=charout(tofile,gin)
   if foo<>0 then do
       foo=write_message(logfile,quiet,reverse'ERROR'normal' unable to write to 'tofile)
       stat.!nocreate=stat.!nocreate+1
       return 0
   end
end 

foo=stream(tempfile,'c','close')
foo=stream(tofile,'c','close')
foo=sysfiledelete(tempfile)
len_stuff=sz
return 1


/*************/
/* write "stuff" string to tofile. tofile should be deleted by do_backfile */
write_stuff_tofile:
   len_stuff=0
   foo=stream(tofile,'c','open write')
   if abbrev(translate(foo),'READY')=0 then do
       foo=write_message(logfile,quiet,reverse'ERROR'normal' unable to open 'tofile)
       stat.!nocreate=stat.!nocreate+1
       return 0
   end 
   aa=charout(tofile,stuff,1)
   bb=stream(tofile,'c','close')
   if aa<>0 then do
       foo=write_message(logfile,quiet,cmm0||reverse'ERROR'normal' problem writing 'tofile)
       fii=sysfiledelete(tofile)
       stat.!nocreate=stat.!nocreate+1
       return 0
   end 
   len_stuff=length(stuff)
   return 1


/***********/
/* write to screen and possibly log file */
write_message:procedure expose bold normal cy_ye reverse logfile cgi_prefix
parse arg lfile,quiet,amessage

if quiet<>1 then do   
 if length(amessage)<80 then
  say amessage
 else
   say left(amessage,75)||' ...'
end

if lfile=0 | lfile='' then return 0
am2=replacestrg(amessage,bold,' ','ALL')
am2=replacestrg(am2,cy_ye,' ','ALL')
am2=replacestrg(am2,normal,' ','ALL')
am2=replacestrg(am2,reverse,' ','ALL')
call lineout lfile,am2
return 1


/***********/
/* adler-32 crc of file aname */
fileadler:procedure expose candorsync bold normal mm0a reverse cy_ye listfile logfile  cgi_prefix
parse arg aname

if candorsync<>1 then return ' '

foo=stream(aname,'c','open read')
if abbrev(strip(translate(foo)),'READY')=0 then return ''

sz=stream(aname,'c','query size')
if sz='' | sz=0 then return ' '
aa=charin(aname,1,min(100000,sz))
adler=rx_adler32(aa)
igot=100000
do forever
       if igot>=sz then leave
      iget=min(100000,sz-igot)
      aa=charin(aname,,iget)
      adler=rx_adler32(aa,adler)
      igot=igot+100000
end
foo=stream(aname,'c','close')
return adler


/**********************/
/* backup old version of file before overwriting */
do_backup:procedure expose norexxlib reverse normal bold cy_ye mm0a listfile logfile  cgi_prefix
parse arg tofile,backfile
 
if backfile='' then do             /* then,delete it */
        fii=sysfiledelete(tofile)
        return 1
end

/* can't use rexxlib */
 if norexxlib=1 then do         /* use 'COPY ' */
    address cmd '@COPY  'tofile' 'backfile ' > nul '
    if rc<>0 then do
       say 'Warning: Unable to copy to backup dir: 'tofile
    end 
    foo=sysfiledelete(tofile)
 end 

 else do                /* use rexxlib? */
 if translate(filespec('d',tofile))=translate(filespec('d',backfile)) then do
          fii=sysfiledelete(backfile)                   /* move old to backup */
          fii=dosrename(tofile,backfile)
          if fii<>1 then do
             say '  Warning: Unable to move to backup dir: 'tofile
             foo=sysfiledelete(tofile)
          end /* do */
 end
 else do                 /* can't move, try copying */
          fii=doscopy(tofile,backfile,'R')
          if fii<>0 then do
             say 'Warning: Unable to copy to backup dir: 'tofile
          end /* do */
          foo=sysfiledelete(tofile)
 end
 end

return 0

/*****/
/* get a string, with a default */
get_string:procedure expose normal bold reverse cy_ye logfile  cgi_prefix rng1 rng2 entries.
parse arg prompt,default,helpproc,ans_ownline

do forever
aa=bold||prompt||normal
if helpproc<>'' then  aa=aa||' [? for help] '

if default<>'' then do
   bb='   ('reverse'ENTER'normal'='default'):'
   if length(aa||bb)>80 then do
      say aa
      say  bb
      call charout,"    "reverse " :" normal' '
   end 
   else do
      say aa||bb
      call charout,"    "reverse " :" normal' '
   end 
   parse pull ans
   if ans='' then ans=default
end
else do
  call charout,aa
  if length(aa)>60 then do
      say
      call charout, '    'reverse':'normal' '
  end
  else do
      if ans_ownline=1 then say 
      call charout, ' 'reverse':'normal' '
  end
  parse pull ans
end 
if ans='?' & helpproc<>'' then do
   interpret 'CALL 'helpproc
   iterate
end /* do */
return ans
end



/***********/
/* ask user to supply a servername and a package */
get_params:

do forever

fromlocal=yesno('Get a list of files to update from','Server File CGI_String ?','S','S')
if fromlocal=3 then do
   call get_params_help
   iterate
end /* do */

if fromlocal=2 then do
  say ' If the central-server is running UpDater as a CGI-BIN script, you'
  say ' must enter the 'bold'CGI-BIN prefix.'normal
  say '    [typically, this is: 'reverse'CGI-BIN/'normal']'
  say ' Otherwise (if UpDater is running as an SRE-http addon), then '
  say ' enter 0 (or leave this empty)'
  cgi_prefix=get_string('Enter "cgi-bin prefix" (or 0)',cgi_prefix)
  if cgi_prefix=0 then cgi_prefix=''
  iterate
end /* do */

if fromlocal=1 then do
   list_of_files=get_string('Name of file containing a "list of files"',list_of_files,'LISTO_HELP')
   list_of_files=strip(list_of_files)
   if list_of_files='' then return ''
   if abbrev(translate(list_of_files),'?DIR')=1 then do
      call show_dirlist 
      iterate
   end 
   ff=stream(list_of_files,'c','query exists')
   if ff='' then do
      say bold"Error"normal" no such file: "list_of_files
      iterate
   end 
end
else do
  list_of_files=''
  cserver=get_string('    IP address of the central server', default_central_server)
  default_central_server=cserver
  thepackage=get_string('    The package name ['normal||reverse'!LIST'normal'=display list of packages]',default_package)
  thepackage=strip(thepackage)
  default_package=thepackage
end
if translate(thepackage)='!LIST' then return 0     /* no need to get destdir */

destdir=get_string('    The destination directory',def_destdir)
def_destdir=destdir

backupdir=get_string('    The backup directory (enter 0 to NOT backup old files)',def_backupdir)
if backupdir=0 then
   backupdir=''
else
   def_backupdir=backupdir

return 1
end 

/***********/
show_dirlist:

parse var list_of_files . thisdir
if thisdir="" then  thisdir=strip(directory(),'t','\')||'\*.*'
say
say reverse ' List of files in: ' normal bold thisdir normal
do while queued()>0
            pull .
end /* do */
'@DIR /b  '||thisdir||' | rxqueue'
foo=show_dir_queue('*')
return 1


/************/
listo_help:
say
say "Select a file that contains the "list of files" contained in a package"
say "on a central server. Typically, this is a list you Saved at some earlier time"
say "(a list you obtained when you updated a package from a central server)"
say
say "Note: "
say bold" * "normal"To display a directory of files, enter "bold"?DIR"normal','
say "     or, "bold"?DIR file_specification"normal
say
return 0

get_params_help:
 say " "
 say ' You can either ask a 'bold'central server'normal' for a list of files, or'
 say ' you can use a 'bold'list of files'normal' that you have on your computer'
 say ' (say, one you obtained earlier).'
 say 
 say ' In either case, the 'bold'list of files'normal' (in this package) will be written'
 say ' relative to a 'reverse'destination directory'normal' on your computer, '
 say ' and old versions can be moved to a 'reverse'backup directory.'normal
 say
 say ' In addition, if the central-server you want to update files from '
 say ' is running UpDater as a CGI-BIN script, you might need to use the '
 say ' CGI_PREFIX option to change the "CGI-BIN prefix"'
 say 
return 0
 

/*********/
/* show stuff in queue as a list */
show_dir_queue:procedure expose qlist. logfile  cgi_prefix
parse arg lookfor
    ibs=0 ;mxlen=0
    if lookfor<>1 then
       nq=queued()
     else
        nq=qlist.0
    do ii=1 to nq
       if lookfor=1 then do
          aa=qlist.ii
          ii2=lastpos('\',aa) ; anam=substr(aa,ii2+1)
       end /* do */
       else do
          parse pull aa
          if pos(lookfor,aa)=0 & lookfor<>'*' then iterate
          parse var aa anam (lookfor) .
          if strip(anam)='.' | strip(anam)='..' then iterate
       end
       ibs=ibs+1
       blist.ibs=anam
       mxlen=max(length(anam),mxlen)
    end /* do */
arf=""
do il=1 to ibs
   anam=blist.il
   arf=arf||left(anam,mxlen+2)
   if length(arf)+mxlen+2>75  then do
        say arf
        arf=""
   end /* do */
end /* do */
if length(arf)>1 then say arf
say
return 1


/***********/
/* given a central server, and a package name, get a package */
get_package:procedure expose temp_dir bold normal cy_ye reverse askupwd logfile cgi_prefix  verbose
parse arg list_of_files,cserver,thepackage,nocache,auser,apwd

/* read from a "cached" file */
if list_of_files<>'' then do
   foo=strip(translate(stream(list_of_files,'c','open read')))
   if abbrev(foo,'READY')<>1 then do
       say  bold"ERROR"normal" unable to open: "list_of_files
       return ''
   end /* do */
   sz=stream(list_of_files,'c','query size')
   if sz=0 | sz='' then do
       say  bold"ERROR"normal" empty file: "list_of_files
       return ''
   end
   stuff=charin(list_of_files,1,sz)
   foo=stream(list_of_files,'c','close')
   return stuff
end 

/* otherwise, read from the server */

if nocache<>1 then
   areq=cgi_prefix'UpDater?action=getl&client=2&package='thepackage
else
   areq=cgi_prefix'UpDater?action=getl&nocache=1&client=2&package='thepackage

stuff=get_a_url(cserver,areq,auser,apwd,,1)

if askupwd=1 then return ''

if stuff='' then do
   say bold"ERROR"normal" problem retrieving "thepackage" package from "cserver
   return ''
end 

return stuff


/***********/
/* parse a package file */
parse_package:procedure expose opts. encrypts encrypt. entries. bold normal reverse cy_ye logfile  cgi_prefix
parse arg stuff

crlf='0d0a'x

parse var stuff hdrline (crlf) stuff
opts.=''
do until hdrline=''
   parse var hdrline aword hdrline
   aword=strip(aword)
   parse var aword atype '=' avalue ; atype=strip(translate(atype))
   if wordpos(atype,'PACKAGE SERVER SELECTOR ENCRYPT GZIP NEEDPRIVS RSYNC')=0 then iterate
   atail='!'||atype
   opts.atail=strip(avalue)
end 

/* check for required fields */
if opts.!SERVER='' then do
   say bold'ERROR'normal' no central server info in package list '
   return ''
end /* do */

if opts.!PACKAGE='' then do
   say bold'ERROR'normal' no  package-name in "list of files" header '
   return ''
end /* do */

/* look for supported encryption */
encrypts=''
key=strip(translate(key))
if opts.!encrypt<>'' & key<>0 then do                 /* see which ones are supported */
   aencrypts=translate(translate(opts.!encrypt,' ',','))
   jj=0
   if strip(aencrypts)='#SIMPLE'  then do
        if norexxlib=1 then
           say 'UpClient Warning: SIMPLE decryption not available (it requires REXXLIB)'
        else
           encrypts='#SIMPLE'
   end 
   else do

    do mm=1 to words(aencrypts)
        aword=strip(word(aencrypts,mm))
        if symbol('ENCRYPT.!'||aword)='VAR' then do
           encrypts=encrypts','aword
        end /* do */
    end        
    encrypts=strip(encrypts,,',')
  end
end

/* read the rest of the file into ENTRIES. */
dirks.=0
filect=0 ; dirct=0
mm=0
do until stuff=''
    parse var stuff aline (crlf) stuff
    aline=strip(aline) 
    if abbrev(aline,';')=1 then iterate
    if aline='' then iterate
    mm=mm+1
    parse var aline entries.mm.!date entries.mm.!entry entries.mm.!file entries.mm.!rdir entries.mm.!noce entries.mm.!crc  entries.mm.!asize .

    dafile=entries.mm.!file
    jj=lastpos('/',dafile)
    goodir='!'left(dafile,jj)
    if dirks.goodir=1 then iterate
    dirct=dirct+1 
    dirks.goodir=1

end /* creating ENTRIES. */

if mm=0 then do
   say
   say reverse"ERROR: "normal"there are no files specified. " 
   say "Perhaps there is a problem with the specification of this package? "
   say 
   return ''
end /* do */
entries.0=mm

say 'Package: 'opts.!package 
say 'which is on the server at: ' opts.!server
say '   # of files: 'entries.0 '(in 'dirct' directories)'
entries.!dirct=dirct

return 0

/****************************/
askopts:
parse arg aopt
aoptd=strip(aopt)

do forever 

say
goo=yesno('Please select an action','Package Update Vu Modify Quit ?',aoptd,'Q')
say

select
  when goo=0 then  aoptd='U'
  otherwise aoptd='?'
end

select
 
 when goo=0 then do
     call get_params  /* return to globals */
 end 

 when goo=1 then return  /* start the update */

 when goo=2 then do
   call vusave
 end

 when goo=3 then do                     /*  get more options */
  call domoreopts
 end

 when goo=4 then do
    foo=sysfiledelete(listfile)
    if logfile<>'' then call lineout logfile
    exit    /* all done */
 end

 otherwise do
    say ' 'cy_ye'UpDateMe'normal' will get files contained in a 'bold'package'normal' on a 'bold'central server'normal','
    say ' and update them to your computer.  UpDateMe uses timestamp comparison, '
    say ' file compression, differencing, and a variety of other techinques in  '
    say ' order to minimize bandwidth requirements.'
    say
    say "Select from the following options: "
    say bold" P "normal'Select package, server, and other parameters.'
    say bold" U "normal'Start updating! '
    say bold" V "normal'View, and save, the "list of files" to update'
    say bold" M "normal'More options: Exclude Range Criteria Username Logfile '
    say bold" Q "normal'Quit the program'
 end

end                     /* select */

end     /* do forever */

/************/
/* view of save results */
vusave:
foo=yesno('View or Save the "list of files to update": ','View Save Return','R','R')
if foo=0 then do
  if viewer='' then
    useview='TYPE '
  else
    useview=viewer
   listfile=get_string('What file to view (using 'useview')',outfile)
   if viewer<>'' then do
      address cmd '@'viewer' 'listfile
   end 
   else do
      address cmd '@TYPE 'listfile' | more'
   end /* do */
end
if foo=1 then do
     call saveout  listfile
end
return 0



/*************************/
/* get more options */
domoreopts:

do forever
joo=yesno(normal'  'reverse'What to change','Exclude Range Criteria Username Logfile Back ?','B','B')
select
   when joo=0 then do
      skiplist=get_string('    Enter a list of files to skip',skiplist,'SKIPHELP',1)
    end

    when joo=1 then do
    say '    Select a range (from the "list of files") of files to UpDate '

    do forever   
      rng1=get_string('  Start at ',rng1,'RNGHELP')
      rng1=strip(rng1)
      if datatype(rng1)<>'NUM' & rng1<>'' then do
         say "Error. Please enter an integer between 1  > 0, or leave blank "
         iterate
      end 

      rng2=get_string('  End at ',rng2,'RNGHELP')
      rng2=strip(rng2)
      if datatype(rng2)<>'NUM' & rng2<>'' then do
         say 'Error. Please enter an integer between 'rng1' and 'entries.0', or leave blank '
         iterate
      end 
      leave
    end
    if rng2>entries.0 then   rng2=entries.0

    end

    when joo=2 then do
      do forever                  /* Update criteria */
         say
         if pos(timecheck,'0123')=0 then 
           dopt='?'
         else
           dopt=substr('ATCM',timecheck+1,1)
         hoo=yesno(normal'    'reverse'Update criteria: ','Timestamp CRC-32  Always ?',dopt,dopt)
         if hoo>1 then hoo=hoo+1
         if hoo=4 then do
            call criteriahelp
            iterate
         end
         hoo=hoo+1
         if hoo=4 then hoo=0
         timecheck=hoo
         leave
      end
      say " "
    end

    when joo=3 then do
        say
        aa=ask_username()
        say
    end

    when joo=4 then do
        say
        logfile=set_logfile(logfile,0)
        say
    end

   when joo=5 then return 0

    otherwise do
       say "Select an  option: "
       say "  "bold"E"normal": Choose files to Exclude (using name patterns)"
       say "  "bold"R"normal": Choose range (from list) of files to update"
       say "  "bold"C"normal": Choose update criteria "
       say "  "bold"U"normal': Specify username, password, and a decryption key'
       say "  "bold"L"normal": Change the log file"
       say "  "bold"B"normal": Go Back to main menu. "
    end
end
end
return 0

criteriahelp:
  say "You can choose when to update a given file. "
  say "The criteria are (from least to most stringent): "
  say "  "bold"T"normal" : Check timestamp first, update if your file is older "
  say "  "bold"C"normal" : Compare 32bit (CRC) hash, update if different "
/*  say "  "bold"M"normal" : Compare 128 bit (MD4) hash, update if different " */
  say "  "bold"A"normal" : Always -- always update file (possibly using RSYNC and GZIP)"
  return

rnghelp:
   say "You can select the range of files, in the file list, to update"
   say "Currently, you've selected " rng1 " to " rng2 
   say "To copy all " entries.0 "files, leave both start and end fields empty"
   say
   return

skiphelp:
   say "You can "bold"skip"normal" (not update) files you select."
   say "To accomplish this, enter a list of filenames."
   say "  "bold"* "normal"use fully-qualified filenames (the name they will have on your computer)"
   say "  "bold"* "normal"seperate each filename with a space "
   say "  "bold"* "normal"you can use * wildcards anywhere (careful, the * wildcard"
   say "    will also match subdirectory names)"
   say "To "bold"not"normal" skip any files, leave this field empty or enter a 0"
   say reverse'Example:'normal' *temp\*  e:\myside\foo.1 e:\myside\users\*.tmp '
   say
   return

/***********/
/* copy filelist to user selected file */
saveout: nop
parse arg oldfile

if storestuff='' then do
   say "You have not "bold"updated"normal" a package, so there is nothing to save"
   return ''
end /* do */

say " "
outget:
tout=temp_dir'\UPDATER.LST'
say 'You can save the "list of files to UpDate" to a file.'
say bold"Enter name of output file (.=quit,ENTER="tout")"normal
call charout,"  "reverse " :" normal
parse pull outfile
if outfile='.' then return 0

if outfile='' then outfile=tout

foo=stream(outfile,'c','query exists')
if foo<>'' then do
    call charout,'    'foo 'exists. '
    arf=yesno(normal"     "bold"Overwrite",,'Y')
    if arf=0 then do
            outfile='' ; signal outget
     end                /* else, command line mode implies overrwrite */
     foo=sysfiledelete(outfile)
     foo=stream(outfile,'c','query exists')
     if foo<>'' then do
            say "      Could not delete "outfile
            outfile=''
            signal outget
     end 
end 

foo=strip(translate(stream(outfile,'c','open write')))
if abbrev(foo,'READY')=0 then do
    say reverse"ERROR."normal" Unable to create "outfile
    return 0
end 
aa=charout(outfile,storestuff,1)
fo=stream(outfile,'c','close')
if aa<>0 then do
   say reverse'ERROR."normal" Unable to write response to 'outfile
   return 0
end /* do */
say "   "bold"Response written to:"normal||outfile


return 1


/***********/
/* copy filelist to user selected file */
set_logfile:procedure expose bold normal cy_ye reverse destdir logfile  cgi_prefix
parse arg logfile,firstdo
if logfile='' then logfile=0
say " "
loutget:

say 'You can write results to a log-file, or enter 'bold"0"normal" to not log results."
say bold"Enter name of log file ("reverse"ENTER="normal||logfile")"normal
call charout,"  "reverse " :" normal
parse pull afile
if afile='' then afile=logfile
if afile=logfile & firstdo<>1 then return logfile /* no change */
if afile=0  then return ''

afile=strip(afile)
if left(afile,1)<>'\' & pos(':',afile)=0 then do
   afile=destdir||'\'afile
end 

foo=stream(afile,'c','close')

foo=stream(afile,'c','query exists')
if foo<>'' then do
    call charout,'    'foo 'exists. '
    arf=yesno(normal"     "bold"Overwrite",,'Y')
    if arf=0 then  signal loutget
     foo=sysfiledelete(afile)
     foo=stream(afile,'c','query exists')
     if foo<>'' then do
            say "      Could not delete "afile
            signal loutget
     end 
end 
foo=stream(afile,'c','open write')
if abbrev(translate(strip(foo)),'READY')<>1 then do
    say "      Could not open "afile
   signal loutget
end

afile=stream(afile,'c','query exists')
say "Log file: "bold||afile||normal
return afile



/* -------------------- */
/* choose between yes and no
 OR, choose between a list of alternatives 
 if yes,no: return 0 for no, 1 for yes
 otherwise, return 0...N-1 (N=# of alterantives, 0= first alternative)

Syntax  (stuff in [ ] is optional) :
 ians=yesno(prompt) or ians=yesno(prompt[,,'Y' or 'N'])
or
 ians=yesno(prompt,anslist[,def_answer,escval,up_arrow_ok])

Where:
  prompt: a prompt to display
 anslist: a space delimited list of 1-word answers
          The first letter of each word MUST BE UNIQUE -- the user
          will choose by pressing this (highlighted) letter
 def_answer: the default answer (the first letter)
 escval: the answer to use when ESC is hit
 arrows_ok: if =1, the the direction keys (arrows, pgup, etc.) return
            -Key_pad_value. Thus, Up yields -8, Home yields -7, etc.
            If 0, direction keys are ignored

NOTES:

 *  You should define the following variables in your calling procedure
   (they are EXPOSED).  They are used to highlight (bold, reverse, etc)
   the questions (note the suggested values can be changed to other ansi
   sequences):
     cy_ye='1b'x||'[37;46;m'
     normal='1b'x||'[0;m'
     bold='1b'x||'[1;m'
     reverse='1b'x||'[7;m'

   If you don't define these,  then the above values will be used.

   IF ANSI SUPPORT IS NOT INSTALLED  -- then set the above =''

  * F1 is interpreted as a "?"

Example:

   whichone=yesno('Choose an option (UP for prior question)', ,
                  'Camel Giraffe Donkey Quit ?','?','Q',1)
*/


/**********************/
yesno:procedure expose normal reverse bold cy_ye   
parse arg amessage,altans,def,escval,arrowok

kesc=c2d(left(normal,1))              /* use default ansi screen contorls */
if kesc<>27 & normal<>'' then do
  cy_ye='1b'x||'[37;46;m'
  normal='1b'x||'[0;m'
  bold='1b'x||'[1;m'
  reverse='1b'x||'[7;m'
end

ony2:
aynn=' '
if def='' then
 defans=''
else
 defans=translate(left(strip(def),1))
if altans='' then altans='No Yes'

w.0=words(altans)
goo0=aynn
do iw0=1 to w.0
     w.iw0=strip(word(altans,iw0))
     a.iw0=translate(left(w.iw0,1))
     aa.iw0=substr(w.iw0,2)
     aynn=aynn||bold
     if  a.iw0=defans then aynn=aynn||cy_ye
     aynn=aynn||a.iw0||normal||aa.iw0
     goo0=goo0||a.iw0||aa.iw0
     if iw0<w.0 then do
       aynn=aynn'  '
       goo0=goo0||'  '
     end
end
if arrowok=1 then aynn=aynn||' [UP]'
ansagain=0

do forever
 ansagain=ansagain+1
 foo1=normal||reverse||amessage||'? '||normal||aynn||': 'normal
 goo=amessage'?'||goo0':'

 if length(goo)<74 then do
    call charout,foo1
 end
 else do
    foo1=normal||reverse||amessage||'? '||normal
    if ansagain=1 then say foo1
    call charout,'   : 'aynn||': 'normal
 end

 anans=translate(sysgetkey('noecho'))
 ianans=c2d(anans)
 if ianans=27 then do    /* esc? then use escval */
   anans=escval
   ianans=c2d(anans)
 end 

 if ianans>33 & ianans<127 then call charout,anans    /* echo lo-ascii answer to screen */

 if ianans=0  then do                   /* function key or arrow */
    anans=sysgetkey('noecho')
    ianans=c2d(anans)
    select
       when anans='3b'x  &  pos('?',altans)>0 then do
          anans='?'
          call charout,'?x'
       end
       otherwise do             /*check for arrow keys */
         arlist='71 72 73 75 76 77 79 80 81 82 83'
         arlist2='-7 -8 -9 -4 -5 -6 -1 -2 -3 -10 -11'
         arlist3='home up pgup left mid right end down pgdn ins del'
         nnn=wordpos(ianans,arlist)
         if nnn>1 & arrowok=1 then do
              ival=strip(word(arlist2,nnn))
              call charout,'['||strip(word(arlist3,nnn))||']'
              say
              return ival
         end 
         call charout,'0d'x
         iterate          /* if here, no match */
       end               /* otherwise */
    end          /* select */
 end            /* function key or arrow */

if anans='' | ianans=13 | ianans=10 then  anans=defans

 do ijj=1 to w.0
    if abbrev(anans,a.ijj)=1 then do
        say
        return Ijj-1
    end
 end /* do */
 call charout,'0d'x
end


/********************/
/* check for unzip and rsync dlls */
check_dlls:

crlf = '0d0a'x

gosock=''

/* --- Load the tcp/ip function library, if necessary --- */
if RxFuncQuery("SockLoadFuncs")=1 then  do    /* not there */
  foo=RxFuncAdd( "SockLoadFuncs","rxSock","SockLoadFuncs")
  if foo=0 then call SockLoadFuncs
end
if RxFuncQuery("SockLoadFuncs")=1 then  do    /* not there */
   say "ERROR: UpDater requires the rxSock dynamic link library"
   call goodbye
   exit
end

/* Load up advanced REXX functions */
if RxFuncQuery("SysLoadFuncs")=1 then  do    /* not there */
  foo=RxFuncAdd( 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs')
  if foo=0 then call SysLoadFuncs
end
if RxFuncQuery("SysLoadFuncs")=1 then  do    /* not there */
   say "ERROR: UpDater requires the rexxutil dynamic link library"
   call goodbye
   exit
end

parse version  atype .
if atype<>"REXXSAA" then do
 say    " WARNING: UpDateMe 1.10 is designed to work under OS/2 Classic Rexx "
 say     "        If you are using some other REXX (such as object rexx) "
 say     "        you might have problems."
end  /* Do */


norexxlib=0
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
 call rxfuncadd 'rexxlibregister','rexxlib', 'rexxlibregister'
 call rexxlibregister
end
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
   say "Note: could not find REXXLIB, some functions will be slower"
   say "(hit ENTER to continue)"
   pull ff
    norexxlib=1
end /* do */

ansion=checkansi()
if ansion=1 then do
  aesc='1B'x
  cy_ye=aesc||'[37;46;m'
cyanon=cy_ye
  normal=aesc||'[0;m'
  bold=aesc||'[1;m'
  re_wh=aesc||'[31;47;m'
  reverse=aesc||'[7;m'
end
else do
  say " Warning: Could not detect ANSI....  Install will look ugly ! "
  cy_ye="" ; normal="" ; bold="" ;re_wh="" ;
  reverse=""
end  /* Do */

if rxfuncquery('rx_md4')=1  then do
   foo=RXFuncAdd( 'RXRsyncLoad', 'RXRSYNC', 'RxRsyncLoad')
   if foo=0 then  call RxRsyncLoad
end
if rxfuncquery('rx_md4')=1  then do
     say "Note: rxrsync.dll is unavailable -- rsync differencing will not be supported "
     candorsync=0
end
else do
   candoadler=1
end /* do */


/* see if GZIP is available */
if rxfuncquery('rxgzLoadFuncs')=1  then do
  foo=RXFuncAdd( 'rxgzLoadFuncs', 'rxgzLIB', 'rxgzLoadFuncs')
  if foo=0 then call rxgzLoadFuncs
end
if rxfuncquery('rxgzLoadFuncs')=1  then do
   candogzip=0
   say "UpDateMe warning: unable to find rxgzlib"
end

/* set some basic variables */


temp_dir=strip(value('TEMP',,'os2environment'),'t','\')

servername=get_hostname()   /* address of this machine */

if datatype(quiet_interval)<>'NUM' then quiet_interval=25

auser='' ; encrypts=''
apwd='' ; shared_secret=''

if cgi_prefix=0 then cgi_prefix=''
storestuff=''

if pos(def_criteria,'0123')>0 then 
   timecheck=def_criteria-1
else
   timecheck=2

return 0

/* ------------- */
sysmkdir2:procedure expose norexxlib reverse normal bold cy_ye mm0a listfile logfile  cgi_prefix
parse arg adir

adir=strip(adir,'t','\')
ff=sysmkdir(adir)
if ff=0 then return ff

/* make the tree */
f2=adir'\'
dd=filespec('d',f2)
pp=filespec('p',f2)
if pp='\' | pp='' then return -1

pp2=strip(translate(pp,' ','\'))

do mm=1 to words(pp2)
   a1=subword(pp2,1,mm)
   a1=translate(a1,'\',' ')
   dd2=dd'\'a1
   hoo=sysmkdir(dd2)
end /* do */

return hoo


/***********/
/* get a url, using socket calls */
get_a_url:procedure expose servername  rsyncok verbose notmod retrys. temp_dir encrypt. ,
                   shared_secret listfile opts. logfile response_tofile ,
                   norexxlib reverse normal bold cy_ye timeout mm0a , 
                   didrsync didgzip orisize diddecrypt askupwd  cgi_prefix gosock
parse arg server,request,username,pwd,oldfile,forcesock,tempfile

crlf = '0d0a'x
sorig_size=''
ith=0

arsyncok=rsyncok
askupwd=0
req0=request
iter=0
notmod=0

if forcesock=1 | gosock='' then do
   gosock=sockhttp_opensock(gosock,server)
   if abbrev(gosock,'-1')=1 then do
      say "Error, unable to create socket to " server
      gosock=''
     exit
  end
end

agin:           /* jump here if problem (and try GET without encoding */

didrsync=0; didgzip=0 ;diddecrypt=0
response_tofile=0

message='GET 'request ' HTTP/1.1'crlf'HOST: 'server||crlf
message=message||'Referer: UpDateMe@'||servername||crlf
if forcesock=1 then message=message||'Connection: close' crlf /* forcesock implies close */

if arsyncok=1 & oldfile<>'' then do
   rsign=rsync_synopsis(oldfile)
   if rsign<>'' then  message=message||'Rsync-signature_updater: 'rsign||crlf
end

if username<>'' then do
   upwd=mk_base64(strip(username)':'strip(pwd))
   upwd='Basic 'upwd
   message=message||'Authorization: '||upwd||crlf
end
message=message||crlf

do oppie=1 to 2
   rc = SockSend(gosock, message)   /* SEND THE REQUEST TO THE SERVER */

/* !!! Now get the response !!!!! */
  got=sockhttp(gosock,timeout,tempfile,10000)  /* WAIT FOR, AND GET, RESPONSE */

  parse var got statline '0d0a'x got              /* get the status */
  parse var statline asockstat sockinfo 
  asockstat=strip(asockstat)
  select                        /* CHECK FOR ERROR CONDITIONS */
    when asockstat=-1 then  do
      say 'ERROR  Unable to complete request: 'sockinfo','gosock
      if datatype(gosock)='NUM' then   foo=sockclose(gosock)
      gosock=''
      return ''
    end
  
    when asockstat=-2 & ith=1 then do
         say 'ERROR  Unable to connect to 'server
         if datatype(gosock)='NUM' then foo=sockclose(gosock)
         gosock=''
         return ' '
    end

    when asockstat=-2 then do
      ith=1
      if verbose>1 then say " Can not reuse " gosock', creating new socket '
      gosock=sockhttp_opensock(gosock,server,httpport)
      if abbrev(gosock,'-1')=1 then do
         say "error connecting: "gosock
         gosock=''
         return ' '
      end 
      iterate           /* try again, with freshly minted socket */
    end

    otherwise leave             /* good response */
   end                  /* select */
end                     /* oppie */

/* IF here, response recieved. Check for non 200 response codes */
parse var sockinfo sockclosed respcode . ; respcode=strip(respcode)

select
  when respcode=401 then do
     say reverse'Username and password required!'normal
     askupwd=1
     if forcesock=1 then  foo=sockclose(gosock)
     return ' '
  end 
  when respcode>399  then do
     say reverse'ERROR'normal' not able ('respcode') to query 'server
     if forcesock=1 then  foo=sockclose(gosock)
     return ' '
  end
  when respcode=304 then do            /* not modified */
      notmod=1
      if forcesock=1 then  foo=sockclose(gosock)
      return ''
   end 
   when respcode=200 then do
      nop
   end 
   otherwise do
     say reverse'ERROR Unknown response code ('respcode') to 'server
     if forcesock=1 then  foo=a_sockclose(gosock,24)
     return ' '
   end  
end

/* if here, got a 200 response code */
if asockstat=1 then do
   gotfile=1
   t2=got
   stuff=tempfile
end 
else do                 /* returned result has headers and body */
   gotfile=0
   findit=crlf||crlf
   ifindit=pos(findit,got)
   t2=substr(got,1,ifindit)
   stuff=substr(got,ifindit+4)             /* THE ENTITY BODY */
end

/* look for varions response headers */
cencoding='';xupdater=''
clen=''

do until t2=''
   parse var t2 ahdr (crlf) t2
   parse upper var ahdr aname ':' avalue
   if strip(aname)='CONTENT-ENCODING' then cencoding=strip(avalue)
   if strip(aname)='X-UPDATER' then xupdater=strip(avalue)
   if strip(aname)='CONTENT-LENGTH' then clen=strip(translate(avalue,' ','0d0a0009'x))
   if strip(aname)='X-NOTMOD' then do
       otmod=strip(translate(avalue,' ','0d0a0009'x))
       if otmod=1 then do
          notmod=2
          if forcesock=1 then  foo=sockclose(gosock)
          return ''
        end
   end
end /* do */

if abbrev(translate(xupdater),'ERROR')=1 then do 
  if verbose>1 then say "ERROR: "||'0d0a'x||got
  if forcesock=1 then  foo=sockclose(gosock)
  return ''  /* some kind of error, give up */
end /* do */

if xupdater<>'' then do
  parse upper var xupdater xup 'MD4=' smd4
  parse upper var xup . 'SIZE=' sorig_size . ',' .
  if datatype(sorig_size)<>'NUM' then sorig_Size=''
end
if gotfile=0 then
   orisize=length(stuff)
else
   orisize=stream(tempfile,'c','query size')



if clen<>''  then do
 if orisize<>clen then do  /* error, not correct amount of bytes recieved */
   say reverse'ERROR'normal' content-length mismatch: 'clen ', actual='||orisize
   if forcesock=1 then  foo=sockclose(gosock)
   return ' '
 end 
end

/* unencode response? */
encodeok=1
badenc=''
if cencoding<>'' then do   /* unencode from right to left */
    cencoding=translate(cencoding,' ',',')

    do jj=words(cencoding) to 1 by -1
        aword=strip(word(cencoding,jj))
        select
           when abbrev(aword,'ENCRYPT=')=1 then do
              if gotfile=1 then do
                  tempfile=do_decrypt(aword,tempfile,1)  /* tempfile will be name of decrypted file */
                  stuff=tempfile
              end
              else do
                 stuff=do_decrypt(aword,stuff)
              end
              if stuff='' then do
                if verbose>1 then say "UpDateMe error: unable to decrypt"
                if forcesock=1 then  foo=sockclose(gosock)
                return ""
              end
              diddecrypt=1
           end 
           when aword='GZIP' then do
              if gotfile=0 then do
                 stuff=do_ungzip(stuff)
              end
              else do
                 tempfile=do_ungzip(tempfile,1)
                 stuff=tempfile
              end
              if stuff='' then do
                if verbose>1 then say "UpDateMe error: bad ungzip"
                encodeok=0
                leave
              end
              didgzip=1
           end
           when aword='GDIFF' then do
              if oldfile='' then do             /* should never happen */
                encodeok=0
                leave
              end /* do */

              if gotfile=1 then do               /* differences are in a file */
                   tempfile2=make_tempname('UD3',norexxlib,temp_dir)
                   stat=rsync_ungdiff_file(oldfile,tempfile,smd4,tempfile2)
                   if stat='' then do
                      if verbose>1 then say 'UpDateMe error: bad ungdiff '  
                      encodeok=0
                      leave
                   end
                   foo=sysfiledelete(tempfile)
                   tempfile=tempfile2
                   stuff=tempfile
              end
              else do                           /* differences are in a string */
                 stuff=rsync_ungdiff(oldfile,stuff,smd4)
                 if stuff='' then do
                    if verbose>1 then say 'UpDateMe error: bad ungdiff '  
                    encodeok=0
                    leave
                 end
              end
              didrsync=1
           end                   /*  GDIFF encoding */
           when aword='IDENTITY' then iterate
           otherwise do
                badenc=badenc' 'aword
                encodeok=0
                leave
           end
        end  /* select */
    end /* cencoding */
end /* cencoding <> '' */

if encodeok=0 then do           /* problem encoding-- retrieve without any encoding ? */
    if iter=0 then do
        areq=''
        do until request=''
            parse var request a1 '&' request ; ta1=translate(a1)
            if abbrev(ta1,'GZIP')+abbrev(ta1,'RSYNC')=0 then areq=areq||'&'||a1
        end 
        request=strip(areq,,'&') ;iter=1 ;arsyncok=0; 
        signal agin
    end /* do */
    else do
        if verbose>0 then say reverse'ERROR'normal' unknown encoding encountered ('badenc') trying w/o encoding'
    end /* do */
end /* do */

if badenc<>'' then do
      say reverse'ERROR'normal' unknown encoding 'badenc
      if forcesock=1 then  foo=sockclose(gosock)
      return ""
end

/* check final size */
if sorig_size<>'' then do
  if gotfile=0 then
         len_final=length(stuff)
  else
         len_final=stream(tempfile,'c','query size')
  if strip(sorig_size)<>len_final then do
       say reverse'ERROR'normal' size ('len_final') does not match original size ('sorig_size')'
       if forcesock=1 then  foo=sockclose(gosock)
       return ""
  end 
end 

if forcesock=1 then  foo=sockclose(gosock)
if gotfile=1 then response_tofile=1
return stuff

/*********************************/
/* find a name for a temporary file */
make_tempname:procedure
parse arg ext,norexxlib,tempdir
ext=strip(ext) ; tempdir=strip(tempdir)

if pos(norexxlib,'01')=0 then do
   norexxlib=rxfuncquery('REXXLIBREGISTER')
end 

if tempdir='' then tempdir=value('TEMP',,'os2environment')

if norexxlib<>0 then
    tfoo='t'||right(date('d')||time('s'),7,'0')
else
    tfoo='t'||right(dospid()||dostid(),7,'0')

tempfile=tempdir'\'tfoo'.'||strip(ext,'l','.')
foo=stream(tempfile,'c','open write')
if abbrev(strip(translate(foo)),'READY')=0 then return ''      /* unable to write to this file */
foo=stream(tempfile,'c','close')
foo=sysfiledelete(tempfile)             /* delete it (possibly 0 length file just created */
if stream(tempfile,'c','query exists')<>'' then return '' /* could not delete */
return tempfile         /* success! */

/***********************************/
/* ask for username & password */
ask_username:procedure expose opts. normal cy_ye bold reverse listfile opts. verbose , 
             auser apwd shared_secret candoadler servername timeout logfile  cgi_prefix

do forever

say "   Enter a username, password, and a decryption-key"
say '   (for the server at 'opts.!server ') '

auser=get_string('     Enter  a UserName ',auser)
auser=space(auser,0)

apwd=get_string("     Enter  a PassWord ",apwd)
apwd=space(apwd,0)

shared_secret=ask_shared(1)
if shared_secret=-1 then iterate
return 0

end

/***********************************/
/* ask user to supply a shared secret password */
ask_shared:procedure expose normal reverse bold cy_ye listfile opts. verbose ,
            auser apwd candoadler timeout servername logfile cgi_prefix shared_secret
parse arg allowagain

do forever
shar=get_string("  Enter  a shared-secret key ",shared_secret,"Shared_secret_help")
shar=space(shar,0)

if candoadler=1 then do         /* requires rxmd4 */

if allowagain<>1 then do
   anans=yesno(normal'     'reverse'Verify this key ',,'N')
end
else do
   anans=yesno(normal'     'reverse'Verify this key (UP-Arrow to reenter username)',,'N','N',1)
   if anans<0 then return -1
end
if anans=1 then do
    nonce=space(translate(date('n')||time('n')||servername),0)
    tocheck=nonce||translate(shar)
    amd4=rx_md4(tocheck)
    req=cgi_prefix'UPDATER?VERIFY='||nonce';'amd4
    stuff=get_a_url(opts.!server,req,auser,apwd,,1)
    stuff=translate(strip(stuff))
    if abbrev(STUFF,'VERIFY=1')=0 then do
       Say ' NO such decryption key for user 'auser' at 'opts.!server
    end
    else do
        say "    Decryption key is okay!"
    end /* do */
end
end

return shar
end


shared_secret_help:
  say
  say   "As a security measure, files in this package can be encrypted before being"
  say   "transmitted over the net.  To de-crypt these files, you must provide"
  say   "a "bold"shared-secret decryption key."normal
  say
  say  bold"Notes:"normal
  say   bold" * "normal"This "bold"key"normal" will be assigned to your "reverse||auser||normal" account"
  say       "    on the server at "opts.!server
  say   bold" * "normal"It is case-insensitive, and should not have embedded spaces. "
  say   bold" * "normal"If you do NOT want to encrypt, enter a "bold"0"normal"."
  say
 return



/***********************************/
/* decrypt a file */
do_decrypt:procedure expose  temp_dir shared_secret  encrypt. listfile bold normal cy_ye reverse logfile ,
                          norexxlib opts. opts. auser apwd
parse arg arg1,astring,isfile

useenc=''
parse var arg1 . '=' a2 ; a2='!'||strip(translate(a2))

if a2='!#SIMPLE' then do
   doit='#SIMPLE'
end 
else do
  if symbol('ENCRYPT.'||a2)<>'VAR' then return ''  /* not supported encrytion type */
  doit=encrypt.a2
end

if shared_secret='' then do
    shared_secret=ask_shared()
end 
shared_secret=translate(shared_secret)

tmpf=make_tempname('1',norexxlib,temp_dir)  /* where the decrypted stuff will be written to */

/* if file, then astring is name of enocded file */
if isfile<>1 then do
   tmpfenc=make_tempname('ENC',norexxlib,temp_dir)
end


/* if simple, do it in memory, and then save to tmpf if isfile=1. */

if  doit='#SIMPLE' then do
  if isfile=1 then do
     oofile=astring
     i1=stream(oofile,'c','query size')
     if i1='' | i1=0 then return ''  /* some kind of problem */
     astring=charin(oofile,1,i1)
     foo=stream(oofile,'c','close')
  end
  else do
  end 
  foo=do_simple_decrypt(shared_secret)   /* astring is exposed */
  if isfile<>1 then return astring
  foo=sysfiledelete(oofile)             /* else, save to old file name */
  joo=charout(oofile,astring,1)         /* (decrypted file becomes working file */
  oog=stream(oofile,'c','close')
  if joo<>0 then do
      foo=sysfiledelete(oofile)
      return ''
  end 
  return oofile  
end 

/* else, non simple -- run an external program or a macrospace procedure */
foo=sysfiledelete(tmpf)
if isfile<>1 then do
    foo=sysfiledelete(tmpfenc)
    joo=charout(tmpfenc,astring,1)
    oog=stream(tmpfenc,'c','close')
    if joo<>0 then do
      foo=sysfiledelete(tmpf)
      foo=sysfiledelete(tmpfenc)
      return ''
    end 
end
else do
     tmpfenc=astring
end

doit=replacestrg(doit,'%IN',tmpfenc,'ALL')
doit=replacestrg(doit,'%OUT',tmpf,'ALL')
doit=replacestrg(doit,'%KEY',shared_secret,'ALL')
doit=strip(doit)
aa=word(doit,1)
signal on syntax name noenc ; signal on  error name noenc

if pos('(',aa)>0 then do
     doit='foo='doit
     interpret doit 
end
else do
     address cmd '@'doit 
end


signal on error name badguys; signal on syntax name badguys
foo=sysfiledelete(tmpfenc)     /* don't need this anymore */

if isfile=1 then do
   return tmpf          /* decrypted file is now the working file */
end


oof=strip(translate(stream(tmpf,'c','open read')))
if abbrev(oof,'READY')=0 then do
  foo=stream(tmpf,'c','close')
  foo=sysfiledelete(tmpf)
  return ''         /* some kind of error */
end
sz=stream(tmpf,'c','query size')
if sz=0 | sz='' then do
  foo=stream(tmpf,'c','close')
  foo=sysfiledelete(tmpf)
  return ''         /* some kind of error */
end
aa=charin(tmpf,1,sz)
foo=stream(tmpf,'c','close')
foo=sysfiledelete(tmpf)
return aa


noenc:          /* jump here on error in decoding software */
signal on error name badguys; signal on syntax name badguys
foo=sysfiledelete(tmpf)
foo=sysfiledelete(tmpfenc)
return ''



/***********************************/
/* decrypt a file */
do_decryptx:procedure expose  temp_dir shared_secret  encrypt. listfile bold normal cy_ye reverse logfile ,
                         cgi_prefix norexxlib
parse arg arg1,astring,isfile

useenc=''
parse var arg1 . '=' a2 ; a2='!'||strip(translate(a2))

if a2='!#SIMPLE' then do
   doit='#SIMPLE'
end 
else do
   if symbol('ENCRYPT.'||a2)<>'VAR' then return ''  /* not supported encrytion type */
   doit=encrypt.a2
end

if shared_secret='' then do
    shared_secret=ask_shared()
end 
shared_secret=translate(shared_secret)

tmpf=make_tempname('1',norexxlib,temp_dir)  /* where the decrypted stuff will be written to */

/* if file, then astring is name ofenocded file */
if isfile<>1 then do
   tmpfenc=make_tempname('ENC',norexxlib,temp_dir)
end /* do */

foo=sysfiledelete(tmpf)
if isfile<>1 then do
  foo=sysfiledelete(tmpfenc)
  joo=charout(tmpfenc,astring,1)
  oog=stream(tmpfenc,'c','close')
  if joo<>0 then do
    foo=sysfiledelete(tmpf)
    foo=sysfiledelete(tmpfenc)
    return ''
  end 
end
else do
  tmpfenc=astring
end

doit=replacestrg(doit,'%IN',tmpfenc,'ALL')
doit=replacestrg(doit,'%OUT',tmpf,'ALL')
doit=replacestrg(doit,'%KEY',shared_secret,'ALL')
doit=strip(doit)
aa=word(doit,1)
signal on syntax name noenc ; signal on  error name noenc

if pos('(',aa)>0 then do
    doit='foo='doit
    interpret doit 
end
else do
   address cmd '@'doit 
end /* do */

signal on error name badguys; signal on syntax name badguys
foo=sysfiledelete(tmpfenc)     /* don't need this anymore */

if isfile=1 then do
   return tmpf          /* decrypted file is now the working file */
end /* do */


oof=strip(translate(stream(tmpf,'c','open read')))
if abbrev(oof,'READY')=0 then do
  foo=stream(tmpf,'c','close')
  foo=sysfiledelete(tmpf)
  return ''         /* some kind of error */
end
sz=stream(tmpf,'c','query size')
if sz=0 | sz='' then do
  foo=stream(tmpf,'c','close')
  foo=sysfiledelete(tmpf)
  return ''         /* some kind of error */
end
aa=charin(tmpf,1,sz)
foo=stream(tmpf,'c','close')
foo=sysfiledelete(tmpf)
return aa



noenc:          /* jump here on error in decoding software */
signal on error name badguys; signal on syntax name badguys
foo=sysfiledelete(tmpf)
foo=sysfiledelete(tmpfenc)
return ''


/************/
/* create a base64 packing of a message */
mk_base64:procedure expose bold normal mm0a  reverse cy_ye listfile logfile  cgi_prefix

do mm=0 to 25           /* set base 64 encoding keys */
   a.mm=d2c(65+mm)
end /* do */
do mm=26 to 51
   a.mm=d2c(97+mm-26)
end /* do */
do mm=52 to 61
   a.mm=d2c(48+mm-52)
end /* do */
a.62='+'
a.63='/'

parse arg mess
s2=x2b(c2x(mess))
ith=0
do forever
   ith=ith+1
   a1=substr(s2,1,6,0)
   ms.ith=x2d(b2x(a1))
   if length(s2)<7 then leave
   s2=substr(s2,7)
end /* do */
pint=""
do kk=1 to ith
    oi=ms.kk ; pint=pint||a.oi
end /* do */
j1=length(pint)//4
if j1<>0 then pint=pint||copies('=',4-j1)
return pint


/*************/
/* get ip address of this machine */
get_hostname:procedure
dot_addr = SockGetHostId()
rc = SockGetHostByAddr(dot_addr, "host.")
return host.name



/***********************************/
/* un gzip a file */
do_ungzip:procedure  expose temp_dir listfile bold reverse normal logfile  cgi_prefix norexxlib
parse arg astring,isfile

if isfile=0 | isfile='' then do
   a2=rxgzInflateString(astring)
   return a2                            /* return as string */
end

tempfile=make_tempname('UD2',norexxlib,temp_dir)
a2=rxgzInflateFile(astring,tempfile)
if a2<>0 then return ''
foo=sysfiledelete(astring)

return tempfile               /* tempfile is now working file */


/*******************************************/
rsync_synopsis:procedure  expose  norexxlib reverse normal bold cy_ye mm0a listfile logfile  cgi_prefix

parse arg afile,nblocks

if nblocks='' then nblocks=45
if datatype(nblocks)<>'NUM' then nblocks=45
if nblocks<10 | nblocks>255 then nblocks=45   /* 255 limit on # of blocks */

if afile='' then return "ERROR no old-version file specified"

/* read "Afile" */
aa=translate(stream(afile,'c','open read'))
if  abbrev(aa,'READY')=0 then return "ERROR could not open "afile
isize=stream(afile,'c','query size')
if isize='' | isize=0 then do
    return reverse'ERROR'normal' 'afile " is unaccessible"
    return ''
end
astuff=charin(afile,1,isize)
aa=stream(afile,'c','close')


blocksize=trunc(0.9999 + (isize/nblocks))
if blocksize<200 then do
    blocksize=200
    nblocks=trunc((isize/blocksize)+0.999)
end /* do */
ac1=d2c(blocksize)
ac1=right(ac1,4,x2c('00'))
ac1=ac1||d2c(nblocks)
iat=1
do mm=1 to nblocks
  if mm=nblocks then
     ablock=substr(astuff,iat)
  else
     ablock=substr(astuff,iat,blocksize)
  acd0=rx_rsync32_md4(ablock)
  ac0=left(x2c(acd0),8)

  ac1=ac1||ac0
  iat=iat+blocksize
end
ac1=mkpack64(ac1)

return ac1

/**********************/
mkPACK64:procedure expose bold normal mm0a  reverse cy_ye listfile logfile  cgi_prefix
parse arg mess

biga=xrange('A','Z')||xrange('a','z')||xrange('0','9')||'+/'

s2=x2b(c2x(mess))

nith=trunc((length(s2)/6)+.9)
cont=copies(' ',nith)
oof=""
do mm=0 to 63
      oof=oof||x2c(b2x(right('00'||x2b(d2x(mm)),6)))
end /* do */
do ith=1 to nith 
  a1=substr(s2,(ith*6)-5,6,0)
  cont=overlay(x2c(b2x(a1)),cont,ith) 
end /* do */
pint=""
pint=translate(cont,biga,oof)
j1=length(pint)//4
if j1<>0 then pint=pint||copies('=',4-j1)
return pint

/************/
/* unpack64   :  astring=unpack64(mkpack64(astring)) */

unpack64:procedure
char_set='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'
do mm=0 to length(char_set)-1
   a.mm=substr(char_set,mm+1,1)
end /* do */

parse arg mess
newmess=""
do mm=1 to length(mess)
   a1=substr(mess,mm,1)
   a1a=c2d(a1)
   select
     when a1a>64 & a1a<91  then a1b=a1a-65  /* ascii 65 to 90 */
     when a1a>96 & a1a<123 then a1b=26+(a1a-97)  /* ascii 97 to 122 */
     when a1a>47 & a1a<58  then a1b=a1a+4   /* ascii 48 to 57 */
     when a1='+' then a1b=62
     when a1='/' then a1b=63
     when a1='=' then iterate
     otherwise return ""        /* error */
   end
   pp=x2b(d2x(a1b))
   if length(pp)>6 then
        pp=substr(pp,3)
   else
        pp=right(pp,6,0)
   newmess=newmess||pp
end
ilen=trunc(length(newmess)/8)*8 ; newmess=left(newmess,ilen)
newm=x2c(b2x(newmess))
return newm



/***************************************************/
/*  rsync_ungdiff: undifference, using a gdiff difference file
                   (that may have have been produced by rsync_gdiff

     status=rsync_ungdiff(oldver_file,diff_file,newfile,GDMD4,verbo)
        OLDVER_FILE -- old version of the file
        diff_file  -- the gdiff file (in a string, or a file)
        gdmd4 -- md4 of "server side" new file -- use as an error check
                 if not specified, then error check will not be done

**************************************/

rsync_ungdiff:procedure expose   norexxlib reverse normal bold cy_ye mm0a listfile logfile ,
                 cgi_prefix temp_dir
  parse arg afile,s1,smd4

/* synopsis is in a string, and return results to a string */

crlf='0d0a'x

/* read "Afile" */
aa=translate(stream(afile,'c','open read'))
if  abbrev(aa,'READY')=0 then do
  say 'ERROR could not open 'afile
  return ''
end
iasize=stream(afile,'c','query size')
if iasize='' | iasize=0 then do
    say 'ERROR unable to apply rsync to 'afile
    return ''
end
astuff=charin(afile,1,iasize)
aa=stream(afile,'c','close')

/* start building, according to the gdiff format */

/* check for gdiff header (char value of 'd1ffd1ff'x, and version # i.e; '04'x)*/
parse var s1 gheader +4 foover +1  s1
ggh=x2c('d1ffd1ff')
if gheader<>ggh then do
    say reverse'ERROR'normal' in difference file: is not a gdiff file: 'c2x(gheader)
    return ''
end

/* ignore version number */
bstuff=''
do forever
   if length(s1)=0 | s1='' then do
       say reverse'ERROR'normal' in RSYNC '
       return ''
   end
   
   parse var s1 atype +1 s1
   itype=c2d(atype)
   select
      when itype=0 then leave   /* 0 signals eof */
      when itype=255 then return 'ERROR gdiff copy operation too large'
      when  itype>0 & itype < 247 then do  /* get itype bytes */
         parse var s1 ccs +(itype) s1
         bstuff=bstuff||ccs
      end /* do */
      when itype=247 then do    /* get <65k bytes */
          parse var s1 jget +2 s1
          jget=c2d(jget)

          parse var s1 ccs +(jget) s1
          bstuff=bstuff||ccs
      end /* do */
      when itype=248 then do    /* get < 2billion bytes */
          parse var s1 jget +4 s1
          jget=c2d(jget)

          parse var s1 ccs +(jget) s1
          bstuff=bstuff||ccs
      end /* do */
      otherwise do   /* copy range of bytes */
         select
           when itype=249 then parse var s1 istart +2 iget +1 s1  
           when itype=250 then parse var s1 istart +2 iget +2 s1
           when itype=251 then parse var s1 istart +2 iget +4 s1
           when itype=252 then parse var s1 istart +4 iget +1 s1
           when itype=253 then parse var s1 istart +4 iget +2 s1
           when itype=254 then parse var s1 istart +4 iget +4 s1
           otherwise return 'ERROR: impossible code in gdiff '
         end
         istart=c2d(istart); iget=c2d(iget)

         bstuff=bstuff||substr(astuff,istart,iget)
      end               /* otherwise range */
   end                  /* gdiff codes */
end                     /* parsing gdiff file */

/* compute md4 of this constructed file */
if smd4<>'' then do 
  b2md4=rx_md4(bstuff)
  if strip(translate(b2md4)) <> strip(translate(smd4)) then do
     say reverse'ERROR'normal' md4 does not match: 'b2md4', 'smd4
     return ''
  end /* do */

end

return bstuff


/***************************************/
/***** call this if "all file" ungdiff */

rsync_ungdiff_file:procedure expose   norexxlib reverse normal bold cy_ye mm0a listfile ,
                logfile  cgi_prefix temp_dir

parse arg oldfile,difffile,smd4,tempfile

crlf='0d0a'x

/* open for read "oldfile" */
aa=translate(stream(oldfile,'c','open read'))
if  abbrev(aa,'READY')=0 then do
  say 'ERROR could not open 'oldfile
  return ''
end
oldsize=stream(oldfile,'c','query size')
if oldsize='' | oldsize=0 then do
    say 'ERROR empty oldfile: 'oldfile
    return ''
end

/* open for read "difffile" */
aa=translate(stream(difffile,'c','open read'))
if  abbrev(aa,'READY')=0 then do
  say 'ERROR could not open 'difffile
   foo=stream(oldfile,'c','close')
  return ''
end
diffsize=stream(difffile,'c','query size')
if diffsize='' | diffsize=0 then do
    say 'ERROR empty diff file: 'difffile
    foo=stream(oldfile,'c','close')
    return ''
end
difffile_left=diffsize ; diffbuffer=''

/* check for gdiff header (char value of 'd1ffd1ff'x, and version # i.e; '04'x)*/
aa=rsync_pull_diff(5,1)
if aa='' then return ''

parse var aa gheader +4 .
ggh=x2c('d1ffd1ff')                     /* ignore version number */
if gheader<>ggh then do
    call rsync_error reverse'ERROR'normal' in difference file: not a gdiff file: 'c2x(gheader)' 'gheader','difffile
    return ''
end

/* start building, according to the gdiff format */
do forever

   atype=rsync_pull_diff(1)
   IF atype='' then return ''
   itype=c2d(atype)

/* process, according to the gdiff code */
   select

      when itype=0 then leave   /* 0 signals eof */
      when itype=255 then do
        call rsync_error  'ERROR gdiff copy operation too large'
        return ''
      end
      when itype < 247 then do  /* get itype (<247) bytes */
         ccs=rsync_pull_diff(itype)
         if ccs='' then return ''
         foo=charout(tempfile,ccs)
         if foo<>0  then do
            call rsync_error 'ERROR writing (a) to 'tempfile
            return ''
         end 
      end /* do */
      when itype=247 then do    /* get <65k bytes from  */
          jget=rsync_pull_diff(2)
          if jget='' then return ''
          jget=c2d(jget)
          ccs=rsync_pull_diff(jget)
          if ccs='' then return ''
          foo=charout(tempfile,ccs)
          if foo<>0  then do
             call rsync_error 'ERROR writing (b) to 'tempfile
             return ''
          end 
      end /* do */
      when itype=248 then do    /* get < 2billion bytes */
          jget=rsync_pull_diff(4)
          if jget='' then return ''
          jget=c2d(jget)
          do mm=1 to jget by 10000
             jget2=min(10000,1+jget-mm)
             ccs=rsync_pull_diff(jget2)
             if ccs='' then return ''
             foo=charout(tempfile,ccs)
             if foo<>0  then do
                call rsync_error 'ERROR writing (c) to 'tempfile
                return ''
             end 
          end           /* to jget by 10000 */
      end /* do */
      otherwise do   /* copy range of bytes from old file */
         
         select
           when itype=249 then do
              s1=rsync_pull_diff(3)
              if s1='' then return ''
              parse var s1 istart +2 iget +1 
           end
           when itype=250 then do
              s1=rsync_pull_diff(4)
              if s1='' then return ''
              parse var s1 istart +2 iget +2 
           end
           when itype=251 then do
              s1=rsync_pull_diff(6)
              if s1='' then return ''
               parse var s1 istart +2 iget +4
           end
           when itype=252 then do
              s1=rsync_pull_diff(5)
              if s1='' then return ''
              parse var s1 istart +4 iget +1 
           end
           when itype=253 then do  
               s1=rsync_pull_diff(6)
              if s1='' then return ''
               parse var s1 istart +4 iget +2
           end
           when itype=254 then do
              s1=rsync_pull_diff(8)
              if s1='' then return ''
              parse var s1 istart +4 iget +4 
           end
           otherwise return 'ERROR: impossible code in gdiff '
         end                    /* 249 to 254 codes */

         istart=c2d(istart); iget=c2d(iget)
         iend3=istart+iget-1
         if iend3>oldsize  then do
             call rsync_error 'ERROR read past end of reference-diff file 'oldfile
             return ' '
         end /* do */
         do mm=istart to iend3 by 10000
             nget=min(10000,1+iend3-mm)
             ccs=charin(oldfile,mm,nget)
             foo=charout(tempfile,ccs)
             if foo<>0  then do
                call rsync_error 'ERROR writing (d) to 'tempfile
                return ''
             end 
         end           /* to jget by 10000 */

      end               /* otherwise get from oldfile */
   end                  /* gdiff codes */

end                     /* parsing gdiff file */

foo=stream(difffile,'c','close')
foo=stream(oldfile,'c','close')
foo=stream(tempfile,'c','close')

/* compute md4 of this constructed file */
if smd4<>'' then do 
  b2md4=rx_md4(tempfile,1)
  if strip(translate(b2md4)) <> strip(translate(smd4)) then do
     say reverse'ERROR'normal' md4 does not match: 'b2md4', 'smd4
     return ''
  end 
end

return tempfile


/*** rsync error handler ******/
rsync_error:
parse arg amess
if amess<>'' then say amess
foo=stream(difffile,'c','close')
foo=stream(oldfile,'c','close')
return ''


/************/
/* pull stuff from difffile, or from difffile's buffer */
rsync_pull_diff:procedure expose diffbuffer difffile difffile_left normal reverse bold logfile 
parse arg nget,i1


do forever              /* may need to dig stuff out of file a few times */

lendiff=length(diffbuffer)
if lendiff>=nget then do
   parse var diffbuffer ccs +(nget) diffbuffer
   if lendiff=nget then diffbuffer=''
   return ccs                           /* success, return nget bytes */
end

/* else, add to diffbuffer */
if difffile_left<1 then do               /* error, buffer can't be filled*/
   call rsync_error nget' ERROR premature end of diff file 'difffile 
   return ''
end 

if i1=1 then
 t1=charin(difffile,i1,min(difffile_left,10000))
else
 t1=charin(difffile,,min(difffile_left,10000))


difffile_left=difffile_left-length(t1)

diffbuffer=diffbuffer||t1

end             /* compare against nget again */


/* ---------------------------------- */
/* return 1 if adir is an existing (possibly empty) directory , 0 if not */
ais_dir:procedure expose norexxlib reverse normal bold cy_ye   mm0a listfile logfile  cgi_prefix
parse arg adir

if norexxlib=0 then do  /* use rexxlib, if available */
   ii=dosisdir(adir)
   return ii
end /* do */

adir=strip(adir)
adir=strip(adir,'t','\')
nowdir=directory()
nowdrive=filespec('d',nowdir'\')
nowpath=filespec('p',nowdir'\')
adr=filespec('d',adir)
if adr='' then do
   if abbrev(adir,'\')=0 then 
       adir=nowdrive||nowpath||adir
   else
       adir=nowdrive||adir
end /* do */

foo=sysfiletree(adir,goo,'D')
if  goo.0>0  then return 1
return 0




 /* ------------------------------------------------------------------ */
 /* function: Check if ANSI is activated                               */
 /*                                                                    */
 /* call:     CheckAnsi                                                */
 /*                                                                    */
 /* where:    -                                                        */
 /*                                                                    */
 /* returns:  1 - ANSI support detected                                */
 /*           0 - no ANSI support available                            */
 /*          -1 - error detecting ansi                                 */
 /*                                                                    */
 /* note:     Tested with the German and the US version of OS/2 3.0    */
 /*                                                                    */
 /*                                                                    */
 CheckAnsi: PROCEDURE
   thisRC = -1

   trace off
                         /* install a local error handler              */
   SIGNAL ON ERROR Name InitAnsiEnd

   "@ANSI 2>NUL | rxqueue 2>NUL"

   thisRC = 0

   do while queued() <> 0
     queueLine = lineIN( "QUEUE:" )
     if pos( " on.", queueLine ) <> 0 | ,                       /* USA */
        pos( " (ON).", queueLine ) <> 0 then                    /* GER */
       thisRC = 1
   end /* do while queued() <> 0 */

 InitAnsiEnd:
 signal off error
 RETURN thisRC


/*****/
goodbye:procedure expose normal reverse
call charout, "...hit "reverse"ENTER"normal" to exit UpDateMe."
parse pull xx
if datatype(gosock)='NUM' then foo=sockclose(gosock)
if datatype(socket)='NUM' then foo=sockclose(socket)
return 0



/************************/
/* wild card match */

wild_match:procedure expose suppress_noslash listfile mm0a bold reverse normal cy_ye logfile  cgi_prefix
parse upper arg needle, haystack ; haystack=strip(haystack)
needle=strip(needle)

noslash=0               /* | at end of haystack means "no / or \ in last wildcarded portion of needle */
if right(haystack,1)='|' & suppress_noslash<>1 then do
   noslash=1
   haystack=left(haystack,length(haystack)-1)
end

hayendast=0
if right(haystack,1)='*' then hayendast=1


if needle=haystack then return -1        /* -1 signals exact match */
ast1=pos('*',haystack)
if ast1=0 then return 0                 /* 0 means no match */
if haystack='*' then  do                /* global is sort of stupid -- choose "shortest" string */
   if noslash=1 then do                 /* check for noslash condition */
     noo=translate(needle,'/','\')
     if pos('/',noo)>0 then return 0
   end
   if length(needle)=0 then 
       return 100000
    else 
        return length(needle)
end
ff=haystack
ii=0
do until ff=""
  ii=ii+1
  parse var ff hw.ii '*'  ff
  hw.ii=strip(hw.ii)
end
if hw.ii='' then ii=ii-1
hw.0=ii


/* check each component of haystackw against needle -- all components
must be there */

resu=' '
istart=1 ; ido=2
if ast1>1 then do       /* first check abbrev */
  if abbrev(needle,hw.1)=0 then return 0   /* first portion of haystack also first portion of needle */
  aresu=length(hw.1)
  if hw.0=1 then do
     if noslash=1 then do                 /* check for noslash condition */
        noo=translate(substr(needle,aresu+1),'/','\')
        if pos('/',noo)>0 then return 0      /* slash in wildcard means "no match" */
     end
     do nm=1 to aresu
        resu=resu||' '||nm
     end /* do */
     return resu         /* if haystacy of form abc*, we have a match */
  end
  ido=2 ; istart=aresu+1
  do mm=1 to aresu
        resu=resu||' '||mm
  end /* do */
end
/* if here, then first part (a non wildcard) of haystack matches first
part of needle
Now check sequentially that each remaining part also exists
*/
do mm=ido to hw.0
  igoo=pos(hw.mm,needle,istart)
  if igoo=0 then return 0
  if noslash=1 & mm=hw.0 & hayendast=0 then do     /* this is a non *'ed haystack end */
     noo=translate(substr(needle,istart,igoo-istart),'/','\')
     if pos('/',noo)>0 then return 0      /* slash in wildcard means "no match" */
  end
  tres=length(hw.mm)
  istart=igoo+tres
  do nn=igoo to (istart-1)
     nn0=nn
     resu=resu||' '||nn       /* resu indices characters that really match */
  end /* do */
end

if noslash=1 & hayendast=1 then do
   noo=translate(substr(needle,nn0+1),'/','\')
   if pos('/',noo)>0 then return 0      /* slash in wildcard means "no match" */
end
   
if (istart >= length(needle)) | (hayendast=1) then  return resu

return 0
 


/* ----------------------------------------------------------------------- */
/* REPLACESTRG:
 newstring=replacestrg(haystack,needle,replacement,type,exact)
  Arguments:
                astring : the "haystack" to look in
                target: the "needle" to look for
                putme: the "new needle" to replace the "needle" with
                type : The direction/type of search
                        FORWARD, BACKWARD, ALL
                exact: YES-- then cases in needle and haystack must match

      Note taht regardless of value of exact, cases are retained in both
      astring and putme.

   Returns the modified astring, or the unmodified astring if target could
   not be found.
*/
/* ----------------------------------------------------------------------- */

replacestrg:procedure expose listfile mm0a bold reverse normal cy_ye logfile listfile  cgi_prefix

exactmatch=0
backward=0 ; doall=0

parse arg astring ,  target   , putme , type , exactmatch

type = translate(type)
if type="BACKWARD" then backward="YES"
if type="ALL" then doall="YES"

iat=1
joelen=length(target)
joelen2=length(putme)

doagain:                /* here if doall=yes */
 if exactmatch="YES" then do
    if   backward="YES" then
        joe= lastpos(target,astring)
    else
        joe= pos(target,astring,iat)
 end
 else do
   if   backward="YES" then
        joe= lastpos(translate(target),translate(astring))
    else
        joe= pos(translate(target),translate(astring),iat)
 end
 if joe=0 then
         return astring

 astring=delstr(astring,joe,joelen)
 if putme<>' ' then
    astring=insert(putme,astring,joe-1)

 if doall="YES" then do
     iat=joe+joelen2
     signal doagain
 end
/* else, all done */
 return astring




/***************************************************/
/***************************************************************************/
/* SOCKhttp: a replacement for a sequence of sockrecv calls; 
             optimized for http requests 

  call as

      stuff=sockhttp(socket,[socket_timeout,tfile,max_notfile])

  where:
      socket == a socket that's been established using sockhttp_opensock
                (or with sockconnect).
               Alternatively, an ip address in the form
                        ii.jj.kk:port
                where
                        ii.jj.kk is an ip address
                        :port is an optional port (:80 is the default)
                If this address is provided, then a socket will be opened, 
                used, and then closed.

                Note: if a socket is provided, it will NOT be closed 
                      (you should close it using stat=sockclose(socket)

    socket_timeout == optional. a timeout value in seconds 
                      (per socket call, default=30)
    tfile    == optional. file to write results to (default, do NOT write to file)
 max_Notfile == optional. maximum response size for writing to string. If response
                > then this, then return headers and put body into tfile
                If 0 (the default), then always write to file 
and
   stuff =  status_line '0d0a'x response

where: 

  status_line: a space delimited set of values:
      stat_code   message

  stat_code: takes values
     -2 = error, probably due to specified socket not being open
     -1 = error 
      0 = success, stuff contains entire response line, response headers & body
      1 = success, stuff contains response line & response headers,
         resonse body will be in tfile.
         This can only happen if  stat tfile<>'' & length(response)>max_notfile 

  message:
     if stat_code<0, then a several word description of the error
     otherwise, wasclosed response_line; where--
        wasclosed: 0 if connection was not closed, 1 if it was
        response_code: the response code (i.e.; 200)


 response:
   if stat_code<0, then stuff will be empty
      stat_code=0, the response headers and body
      stat_code=1, the headers (body will be in tfile)

Example:
   stuff=sockhttp(,,'foo.tmp')
   parse var stuff statline '0d0a'x stuff1
   parse var statline statcode message
   select 
     when statcode<0 then say "Error message: "message
     when statcode=0 then do
          parse message wasclosed response_code
          parse var stuff1 response_headers '0d0a0d0a'x response_body
      end
     when statcode=1 then do
       response_headers=stuff1   / * response_body is in foo.tmp * /
     end
     otherwise
   end


Notes:
    * if tfile not defined, then max_notofile is ignored
    * see "user changable parameters" for some default values
    * socket_timeout refers to maximum seconds between "sockrecv" requests. 
      It does NOT refer to total length of time required to recieve a message.
      Thus, a number of medium length delays (say, a few seconds required
      to complete each of several sockrecv requests) will NOT cause a timeout 
      (in other words, the timeout counter is reset upon each successful 
      completion of a 1000 byte sockrecv request).
  
*/

SOCKhttp:PROCEDURE expose bold normal cy_ye reverse logfile mm0a verbose

/* ------------ User changable parameters  --------------------- */

/* default time out in seconds for each set of socket calls
   (if timeout argument not given) */
def_socket_timeout=30

/* default value of max_notfile */
def_max_notfile=0       /* if tfile specified, 0 means "always write body to tfile*/

/* maximum length of response. If response > than this, an error is returned */
maxlen=1000000000  /* 1 gigabyte */

/* ------------ end of user changable parameters -----------------*/

PARSE Arg socket,socket_timeout,tfile,max_notfile                    


if datatype(socket_timeout)<>'NUM' then socket_timeout=def_socket_timeout
if datatype(socket_timeout)<>'NUM' then do
   return '-1 Bad socket timeout value : 'socket_timeout
end 

if datatype(max_notfile)<>'NUM' then max_notfile=def_max_notfile
if datatype(max_notfile)<>'NUM' then do
   return '-1 Bad max_notfile value : 'max_notfile
end 

if maxlen='' then maxlen=1000000000
if datatype(maxlen)<>'NUM' then do
   return '-1 Bad maxlen value : 'maxlen
end 

isclosesock=0
if pos(".",socket)>0 then do             /* socket is an ip address */
   parse var socket anip ':' aport ; aport=strip(aport) ;anip=strip(anip)
   if aport=''  then aport=80
   socket=sockhttp_opensock(,anip,aport)
   if abbrev(socket,'-1')=1 then return '-1 Unable to create socket '
   isclosesock=1
end /* do */


if verbose>1 then say "Socket will wait for " socket_timeout " seconds ...."

/* READY to start recieving */

if Sockioctl(socket,'FIONBIO',1) = -1 then  do      /* switch to nonblocking mode */
   Return '-1 crashed in sockioctl 'socket':'errno
end

/* global parameters */
incoming=''
fileon=0
rheaders=''
clen='' ; ischunked=0
len_toget=''
wasclosed=0
trailers=''

ict=0

/* first, get header */
call sockhttp_headers    /* also sets ichunked, incoming, and clen */

ares=result
if ares<>'' then do
  if isclosesock=1 then do
      foo=sockclose(socket)
  end
  return ares    /* ares might be an error message, starting with -1 */
end

if rheaders='' then do
say 'noh '
   return '-1 ERROR could not read headers '
end 

parse var rheaders respline '0d0a'x response
parse var respline . icode .

if icode>299 & icode<400 then do        /* 300, hence no body */
/*say icode' withh 'sockET */
   return '0 0 'icode||'0d0a'x||rheaders
end


/* 3 ways of sending data
1) with content-length header
2) using chunked encoding
3) closing connection at end of data transferal */

if ischunked<>1 then do
   if len_toget=0 then
        nop             /* incoming was gotten */
   else
        call sockhttp_nonchunk
end
else do
   call sockhttp_chunk
   if verbose>0 then say ''
   if trailers<>'' then rheaders=rheaders||'0d0a'x||trailers
end

/* did an error occur? */
ares=result
if ares<>'' then do
  if isclosesock=1 then foo=sockclose(socket)
  return ares    /* ares might be an error message, starting with -1 */
end

if sockioctl(socket,'FIONBIO',0) = -1 then do          /* switch to blocking mode */
    if verbose>0 then say 'Sockhttp: ioctl error on switch to blocking mode: ' errno
end

parse var rheaders respline '0d0a'x response
parse var respline . icode .
daclosed=0
if wasclosed=1 | isclosesock=1 then do
  daclosed=1 
  foo=sockclose(socket)
end

if fileon=0 then 
   return '0 'wasclosed' 'icode||'0d0a'x||rheaders||'0d0a0d0a'x||incoming
else
   return '1 'wasclosed' 'icode||'0d0a'x||rheaders


/***** ----------------- ***/
/* read header section (and response line)
  Sets:  rheaders, incoming, ischunked, clen 
if no error, return ''. Otherwise, return '-1 error message */

sockhttp_headers:

i1000=600
timeout=socket_timeout
Do While TimeOut > 0

    res=Sockrecv(socket,'data',i1000) 

    if res=0 then do
       return '-1 Socket prematurely closed'
    end /* do */

    if res<0 then do                           /* error condition ? */
      If errno <> 'EWOULDBLOCK' THEN  do      /* real crash ? */
          if errno='ECONNRESET' | errno='ENOTSOCK' then  do
              Return '-2 socket closed?  '  /* might be bad socket */
          end
          else do
              Return '-1 crashed in sockrecv 'errno  /* yes, real crash */
          end
      end

      /* not a crash, but no data available:  errno = EWOULDBLOCK & sockrecv returned -1 */

      ict=ict+1;     if verbose>1 then say 'SockHttp_headers: Waiting ('ict')...'

      goo=syssleep(0.25)           /* relinquish the CPU for one second, this is from REXXUTIL */

      TimeOut = TimeOut - 0.25 /* count down my timer */
      Iterate                    /* loop again */
   End                           /* if sockrecv = -1 */
   if res<0 then return "-1 Socket timed out " 
   ikk=pos('0d0a0d0a'x,data)

   if ikk=0 then do                /* all of DATA is header info */
      rheaders=rheaders||data
      iterate                   /* sockrecv next block */
   end

/* if here, got all of the headers */
  rheaders=rheaders||left(data,ikk-1)
  if verbose>1 then say length(rheaders)||' bytes of request headers'

  incoming=substr(data,ikk+4)          /* get beginning of content */

/* find content-length, or "chunked" transfer-encoding */
   rhh=rheaders
   do until rhh=''
       parse var rhh aline '0d0a'x rhh
       parse upper var aline aname ':' aval ;
       aname=strip(translate(aname)) ; aval=strip(translate(aval))
       select 
           when aname='CONTENT-LENGTH' then clen=aval
           when aname='TRANSFER-ENCODING' then do
               if pos('CHUNKED',aval)>0 then ischunked=1
           end
           otherwise nop
       end
    end             /* found end of response headers */
    if clen<>'' then do
        if verbose>1 then  say "Content-length = "clen
        len_toget=clen-length(incoming)
    end
    if ischunked=1 & verbose>1 then say "Using chunked encoding "  
    leave
end                 /* building rheaders */
return ''               /* blank return signals okay */

/**************************/
/* chunked read of content   sets INCOMING, WASCLOSED, FILEON; writes to TFILE */

sockhttp_chunk:
buffer=incoming         /* left over from header read */
i1000=1000
incoming=''

totbytes=0
if verbose>0 then call charout,'Bytes read: 'totbytes||'0d'x

do forever              /* come here to read another chunk */

   if verbose>0 then call charout,'Bytes read: 'totbytes||'0d'x

   if length(incoming)>max_notfile & tfile<>'' then do
        call write_to_tfile
   end 

  ipos=pos('0d0a'x,buffer)
  if ipos=0 then do                  /* recharge buffer */
     data=sockin(socket,i1000,socket_timeout,verbose)
     parse var data scode '0d0a'x buffer0 

     if scode<0 then return data   /* some kind of error */
     if scode=0 | buffer0='' then return '-1 {a} premature close of chunked response'
     buffer=buffer||buffer0
     totbytes=totbytes+length(buffer0)
     iterate
  end      

/* determine size of chunk */
  aa=left(buffer,ipos-1)
  buffer=substr(buffer,ipos+2)
  parse var aa gg ';' .
  gtsize=x2d(strip(gg))

  if gtsize=0 then leave               /* no more content to get */
  if gtsize<0 then return '-1 error reading chunk size '

/* is this chunk||crlf within the buffer */
  if (gtsize+2)<=length(buffer) then  do
     incoming=incoming||left(buffer,gtsize)
     if gtsize+2=length(buffer) then
        buffer=''
     else
        buffer=substr(buffer,gtsize+3)    /* buffer now starts with a new chunk */
     iterate                        /* extract next chunk, either from buffer or from sockin */
  end

/* chunk is larger then the buffer */
  toget=(gtsize+2)-length(buffer)       /* note that chunk always has appended crlf */
  if toget<3 then do            /* special case (dangling cr or crlf */
     if toget=1 then 
        incoming=incoming||left(buffer,length(buffer)-1)
     else
        incoming=incoming||buffer

     data=sockin(socket,toget,socket_timeout,verbose)
     parse var data scode '0d0a'x data 
     if scode<0 then return data   /* some kind of error */
     if scode=0 then return '-1 {b} premature close of chunked response'
     buffer=''          /* get next chunk from sockin */
     totbytes=totbytes+length(data)
     iterate
  end

/* buffer does not contain entire chunk; so sockin some more */
  incoming=incoming||buffer

/* read chunks via calls to sockin */
  do forever            /* get this "chunk" in 1000 byte increments */
    j1000=min(1000,toget)            /* get trailing crlf */
    data=sockin(socket,j1000,socket_timeout,verbose)
    parse var data scode '0d0a'x data 
    if scode<0 then return data   /* some kind of error */
    if scode=0 then return '-1 {c} premature close of chunked response'

    lendata=length(data)
    totbytes=totbytes+lendata

    toget=toget-lendata
    if toget=0 then do        /*  end of chunk  */
        incoming=incoming||left(data,lendata-2)
        buffer=''
        leave
    end 
    else do             
        incoming=incoming||data
    end


  end                   /* forever for this chunk */

/*  large resource and tfile available?  save it to a file */
   if length(incoming)>max_notfile & tfile<>'' then do
        call write_to_tfile
   end
    
end             /* get get next chunk (exit via LEAVE */


if fileon=1 then do
    astat=sock_closetfile()
    if astat<>'' then return astat   /* error if not '' */
end

if wasclosed=1 then return ''           /* closed, to stop here */
if buffer='0d0a'x then do
  wasclosed=0
  return ''        /* no trailers */
end

if right(buffer,4)='0d0a0d0a'x then do
   trailers=left(buffer,length(buffer)-4)        
   wasclosed=0
   return ''
end

trailers=buffer

do mm=1 to 50           /*50k trailer max */
  data=sockin(socket,i1000,socket_timeout,verbose)
  parse var data scode '0d0a'x data
  if scode<0 then return data   /* some kind of error */
  if scode=0 then do          /* conection closed */
    wasclosed=1
    return ''
  end
  trailers=trailers||data
  if right(trailers,4)='0d0a0d0a' then do
     trailers=left(trailers,length(trailers)-4)
     wasclosed=0
     return ''
  end
end
say 
return '-1 trailers too long '


/*************/
/* possibly write incoming to tfile */
write_to_tfile: 
      if fileon=0 then do               /* initialize file */
          foo=stream(tfile,'c','close')
          foo=sysfiledelete(tfile)
          foo=strip(translate(stream(tfile,'c','open write')))
          if abbrev(foo,'READY')=0 then Return '-1 unable to open file: 'tfile
          fileon=1
      end
      nm=charout(tfile,incoming)
      if nm<>0 then return '-1 error writing to file '
      incoming=''
   end 
return


/*********----------------*****************/
/* non-chunked read of content
  sets INCOMING, WASCLOSED, FILEON; writes to TFILE */

sockhttp_nonchunk:

i1000=1000
Do forever              /* build up one socket call at a time */

    if len_toget<>'' then do
        i1000=min(1000,len_toget)
    end 
    data=sockin(socket,i1000,socket_timeout,verbose)

/*  parse out status and data: -1=error, 0=closed,1=data */
    parse var data scode '0d0a'x data

    if scode<0 then return data   /* some kind of error */

    if scode=0 then do          /* conection closed */
       if fileon=1 then do
          astat=sock_closetfile()
          if astat<>'' then return astat   /* error if not '' */
       end
       wasclosed=1
       return ''
    end

/* if here, still building (sockinstat=0) */

   incoming=incoming||data

   if verbose>1 then say "SockHttp_nochunk: total data recieved: "length(incoming) 

   if length(incoming)>maxlen then return '-1 Maxlen exceeded 'maxlen

/*  large resource and tfile available?  save it to a file */
   if length(incoming)>max_notfile & tfile<>'' then do
      if fileon=0 then do               /* initialize file */
          foo=stream(tfile,'c','close')
          foo=sysfiledelete(tfile)
          foo=strip(translate(stream(tfile,'c','open write')))
          if abbrev(foo,'READY')=0 then Return '-1 unable to open file: 'tfile
          fileon=1
      end
      nm=charout(tfile,incoming)
      if nm<>0 then return '-1 error writing to file '
      incoming=''
   end 

   len_toget=len_toget-length(data)

   if len_toget=0 then do                 /* content-length bytes have been read */
       if fileon=1 then do
          astat=sock_closetfile()
          if astat<>'' then return astat   /* error if not '' */
       end
       wasclosed=0              /* though it might be closed on next read */
       return ''
   end 

End              /*  ------ get next sockrecv */

/* should never get here */


/* ------------------ */
/* write to tfile, and close  */
sock_closetfile:
 nm=0
 if incoming<>'' then nm=charout(tfile,incoming)
 if nm<>0 then do
    if verbose>0 then say "ERROR: unable to write to file: "tfile
     Return '-1 unable to write to file'
 end 
 foo=stream(tfile,'c','close')        /* don't bother checking for error, but we could */
 return ''



/*******/
/* non blocking sockrecv  */
sockin:procedure   expose bold normal cy_ye reverse logfile mm0a
parse arg socket,i1000,socket_timeout,verbose

atimeout=socket_timeout
if atimeout='' then atimeout=30
if verbose='' then verbose=0

ict=0

Do While aTimeOut > 0
    res=Sockrecv(socket,'data',i1000) 

    select 

      when res<0 then do                           /* error condition, or nothing recived? */
         If errno <> 'EWOULDBLOCK' THEN  do
            if errno='ECONNRESET' then
                Return '-2 socket (sockin) closed?  '  /* yes, real crash */
            else 
               Return '-1 crashed in sockin 'errno  /* yes, real crash */
         end

/* else not a crash, but no data available (errno = EWOULDBLOCK & sockrecv returned -1)  */
         ict=ict+1
         if verbose>1 then say 'SockIn: Waiting ('ict')...'
         goo=syssleep(0.25)           /* relinquish the CPU for one second, this is from REXXUTIL */

         aTimeOut = aTimeOut - 0.25 /* count down my timer */
         Iterate                    /* loop again */
      End                           /* if sockrecv = -1 */

      when res<-1 then do            /* some other error */
         Return '-1 Error in sockin 'errno  
      end 

      when res=0 then return '0'     /* signal "closed connection */

      otherwise return '1'||'0d0a'x||data

   end
        
end             /* timeout */
return '-1 timeout'             /* if here, atimeout<0 */


/********************************************/
/* open up a socket ----------- **/
/* note that gosock is returned, or -1 error message  */ 
sockhttp_opensock:procedure   expose bold normal cy_ye reverse logfile mm0a

parse arg gosock,server,httpport

if httpport='' then do
    if abbrev(translate(server),'HTTP://')=1 then parse var server . '://' server 
    parse var server server ':' httpport
end /* do */

if datatype(gosock)='NUM' then rc = SockClose(gosock)   /* close gosock? */

server=strip(server)
httpport=strip(httpport)
if httpport="" | datatype(httpport)<>'NUM' then httpport=80
crlf = '0d0a'x

family  ='AF_INET'

rc=1
if verify(server,'1234567890.')>0 then 
   rc=sockgethostbyname(server, "serv.0")  /* get dotaddress of server */
else
  serv.0addr=strip(server)

if rc=0 then  return '-1 ERROR Unable to resolve 'server

dotserver=serv.0addr                    /* .. */
gosaddr.0family=family                  /* set up address */
gosaddr.0port  =httpport
gosaddr.0addr  =dotserver

gosock = SockSocket(family, "SOCK_STREAM", "IPPROTO_TCP")
rc = SockConnect(gosock,"gosaddr.0")
if rc<0 then do 
     return '-1   Unable to connect to 'server' 'rc
end

return gosock


/* ======== */
do_simple_decrypt:procedure expose astring
parse arg akey
instuff=length(astring)

aa=stringcrc(akey)

cc=c2x(aa)
ix=max(2,x2d(substr(cc,1,2)))
iy=max(2,x2d(substr(cc,3,1)))
iz=max(2,x2d(substr(cc,4,1)))

numeric digits 12
j4=4
mx32=4294967295

amask=''
irepeat=20+(iy//28)
ii=0
do forever
  arand=random3(mx32)
  darand=right(d2c(arand),j4,0)
  amask=darand||amask||darand
  if (ii//irepeat)=1 then amask=amask||amask
  if length(amask)>instuff then leave
  ii=ii+1
end

 /* aanew=bitxor(stuff2,left(amask,instuff))           THIS IS THE ENCRYPTED RESULT !!!  */

astring=bitxor(astring,left(amask,instuff))               /* THIS IS THE DECRYPTED RESULT !!!  */
return 1


/* *********************** */
/* UNIFORM DISTRIBUTION RANDOM # GENERATOR.
  FROM APPL STATIS 1982, VOL31 Pg183 */

random3:procedure expose ix iy iz
parse arg mx32
IX=(171*IX)//30269
IY=(172*IY)//30307
IZ=(170*IZ)//30323
RANDOM=(IX/30269.) + (IY/30307.)  + (IZ/30323)
random=trunc((random // 1.0)*mx32)

RETURN random


